package game
{
   public class Model
   {
      
      public static var _KEY_DOWN:Boolean = false;
      
      public static var userName:String = "PLYAER1";
      
      public static var ExitData:Object;
      
      public static var _disableKeyBoard:Boolean = false;
      
      public static var state:String = "normal";
      
      public static const MAX_MOVE_SPEED:Number = 2;
      
      public static var ran:Number = 0;
      
      public static var gridWidth:Number;
      
      public static var books:Array;
      
      public static var cData:Object;
      
      public static var isGameOver:Boolean = false;
      
      public static const MAX_DROP_SPEED:Number = 25;
      
      public static var isStatic:Boolean;
      
      public static var _KEY_UP:Boolean = false;
      
      public static const MOVING_A:Number = 0.3;
      
      public static var isSleep:Boolean = false;
      
      public static var jumped:int = 0;
      
      public static const a:Number = 0.5;
      
      public static var gravity:Object = {
         "x":0,
         "y":a
      };
      
      public static var died:int = 0;
      
      public static var _KEY_LEFT:Boolean = false;
      
      public static var rotated:int = 0;
      
      public static var hiddedRoomLocation:Object;
      
      public static var _instance:Model;
      
      public static var hasP:Boolean;
      
      public static var _KEY_RIGHT:Boolean = false;
      
      public static var rotation:Number = 0;
       
      
      public var mapEntrances:Array;
      
      public var currentLevel:uint = 0;
      
      public var hiddenRoomSets:Array;
      
      public var mapData:Object;
      
      public var callBacks:Array;
      
      public var currentRoomId:uint;
      
      public var currentData:Object;
      
      private var messages:Array;
      
      private var cRoom:Array;
      
      public var roomLevel:Array;
      
      public var allData:Object;
      
      public var levels:Array;
      
      public var currentRoom:Room;
      
      public var rooms:Array;
      
      private var cMan:Array;
      
      public function Model()
      {
         currentLevel = 0;
         super();
         mapEntrances = new Array();
         rooms = new Array();
         levels = new Array();
         callBacks = new Array();
         roomLevel = new Array();
         createMainMap();
         setMessage();
         addEntrances();
         createLevels();
         createHiddenRoom();
         getAllData();
      }
      
      public static function get KEY_RIGHT() : Boolean
      {
         if(_disableKeyBoard || isGameOver)
         {
            return false;
         }
         return _KEY_RIGHT;
      }
      
      public static function get KEY_LEFT() : Boolean
      {
         if(_disableKeyBoard || isGameOver)
         {
            return false;
         }
         return _KEY_LEFT;
      }
      
      public static function getInstance() : Model
      {
         if(_instance == null)
         {
            _instance = new Model();
         }
         return _instance;
      }
      
      public static function resetData() : void
      {
         jumped = 0;
         ran = 0;
         died = 0;
         rotated = 0;
      }
      
      public static function get KEY_UP() : Boolean
      {
         if(_disableKeyBoard || isGameOver)
         {
            return false;
         }
         return _KEY_UP;
      }
      
      public static function set disableKeyBoard(param1:Boolean) : void
      {
         _disableKeyBoard = param1;
      }
      
      public static function get KEY_DOWN() : Boolean
      {
         if(_disableKeyBoard || isGameOver)
         {
            return false;
         }
         return _KEY_DOWN;
      }
      
      public static function get disableKeyBoard() : Boolean
      {
         return _disableKeyBoard;
      }
      
      public function getCurrentData() : Object
      {
         if(allData[userName] == null)
         {
            allData[userName] = new Object();
         }
         currentData = allData[userName];
         return currentData;
      }
      
      private function get2DArray(param1:Array, param2:Array, param3:Array = null) : Array
      {
         var _loc4_:Array = null;
         var _loc5_:int = 0;
         var _loc6_:int = 0;
         if(param3 == null)
         {
            param3 = new Array();
         }
         _loc4_ = new Array();
         _loc5_ = int(param1[0]);
         while(_loc5_ <= param2[0])
         {
            _loc6_ = int(param1[1]);
            while(_loc6_ <= param2[1])
            {
               _loc4_.push([_loc5_,_loc6_]);
               _loc6_++;
            }
            _loc5_++;
         }
         return _loc4_.concat(param3);
      }
      
      public function createLevels() : void
      {
         createRoom(9,9);
         addGroup(get2DArray([0,1],[0,3]));
         addGroup(get2DArray([0,5],[0,7]));
         addGroup(get2DArray([8,0],[8,8]));
         addGroup(get2DArray([0,0],[7,0]));
         addGroup(get2DArray([0,8],[7,8]));
         addGroup([[4,2],[6,3],[7,3],[3,4]]);
         addGroup(get2DArray([2,3],[2,7]));
         addGroup(get2DArray([5,2],[5,5]));
         addGroup(get2DArray([4,6],[6,6]));
         addGroup([[1,7]],"key",false);
         addGroup([[7,6]],"door",true,90);
         addGroup([[7,4]],"key",false);
         addGroup([[5,1]],"door",true);
         addGroup([[7,2]],"key",false);
         addGroup([[0,4]],"door",true);
         addGroup([[4,5]],"book",false,1);
         addGroup([[-1,4]],"exit",true,"T0");
         setManPosition([[1,4]]);
         addGroup([[4,4]],"man",false);
         createRoom(18,9);
         addGroup([[0,12]]);
         addGroup(get2DArray([0,0],[0,10]));
         addGroup(get2DArray([0,14],[0,17]));
         addGroup(get2DArray([8,0],[8,17]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,17],[7,17]));
         addGroup([[5,6],[7,4],[2,2],[6,2],[5,8],[6,4],[6,10],[2,8],[3,4],[3,8],[3,9],[4,3],[4,4],[4,6]]);
         addGroup(get2DArray([1,10],[3,10]));
         addGroup([[0,11]],"spike",true,180);
         addGroup([[0,11]],"halfWall",true,180);
         addGroup([[1,6]],"spike",true,270);
         addGroup([[1,6]],"halfWall",true,270);
         addGroup([[2,6]],"spike",true,270);
         addGroup([[2,6]],"halfWall",true,270);
         addGroup([[3,6]],"spike",true,270);
         addGroup([[3,6]],"halfWall",true,270);
         addGroup([[5,4]],"spike",true,270);
         addGroup([[5,4]],"halfWall",true,270);
         addGroup([[6,8]],"spike",true,270);
         addGroup([[6,8]],"halfWall",true,270);
         addGroup([[7,8]],"spike",true,270);
         addGroup([[7,8]],"halfWall",true,270);
         addGroup([[4,10]],"spike",true,270);
         addGroup([[4,10]],"halfWall",true,270);
         addGroup([[5,10]],"spike",true,270);
         addGroup([[5,10]],"halfWall",true,270);
         addGroup([[3,14],[4,13],[4,14],[4,15],[5,12],[5,13],[5,14],[5,15],[6,12],[6,13],[3,13],[4,12],[3,15],[4,16],[6,15],[5,16],[6,14],[7,15]],"piston",false);
         addGroup([[2,12]],"key",false);
         addGroup([[1,8]],"door",true,90);
         addGroup([[2,9]],"key",false);
         addGroup([[0,13]],"door",true);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[-1,13]],"exit",true,"T1");
         setManPosition([[4,1],[1,13]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup([[0,7],[0,8],[1,8],[7,8],[8,5],[8,7],[8,8]]);
         addGroup(get2DArray([0,0],[0,4]));
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup([[6,1],[1,4],[4,4],[5,4],[6,6],[2,2],[6,2]]);
         addGroup([[8,6]],"spike",true,0);
         addGroup([[8,6]],"halfWall",true,0);
         addGroup([[3,2]],"spike",true,270);
         addGroup([[3,2]],"halfWall",true,270);
         addGroup([[5,2]],"spike",true,270);
         addGroup([[5,2]],"halfWall",true,270);
         addGroup([[2,6]],"spike",true,90);
         addGroup([[2,6]],"halfWall",true,90);
         addGroup([[3,6]],"spike",true,90);
         addGroup([[3,6]],"halfWall",true,90);
         addGroup([[4,6]],"spike",true,90);
         addGroup([[4,6]],"halfWall",true,90);
         addGroup([[5,6]],"spike",true,90);
         addGroup([[5,6]],"halfWall",true,90);
         addGroup([[0,5]],"spike",true,180);
         addGroup([[0,5]],"halfWall",true,180);
         addGroup([[0,6]],"spike",true,180);
         addGroup([[0,6]],"halfWall",true,180);
         addGroup([[5,3]],"spike",true,180);
         addGroup([[5,3]],"halfWall",true,180);
         addGroup([[5,5]],"spike",true,180);
         addGroup([[5,5]],"halfWall",true,180);
         addGroup([[2,4]],"spike",true,270);
         addGroup([[2,4]],"halfWall",true,270);
         addGroup([[2,8]],"spike",true,270);
         addGroup([[2,8]],"halfWall",true,270);
         addGroup([[3,8]],"spike",true,270);
         addGroup([[3,8]],"halfWall",true,270);
         addGroup([[4,8]],"spike",true,270);
         addGroup([[4,8]],"halfWall",true,270);
         addGroup([[5,8]],"spike",true,270);
         addGroup([[5,8]],"halfWall",true,270);
         addGroup([[6,8]],"spike",true,270);
         addGroup([[6,8]],"halfWall",true,270);
         addGroup([[5,1]],"key",false);
         addGroup([[7,2]],"door",true,90);
         addGroup([[7,1]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[9,4]],"exit",true,"B1");
         setManPosition([[4,1],[7,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup([[13,9],[15,9],[1,17],[3,17],[5,17]]);
         addGroup(get2DArray([0,0],[0,17]));
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([8,5],[8,9]));
         addGroup(get2DArray([17,9],[17,17]));
         addGroup(get2DArray([1,0],[7,0]));
         addGroup(get2DArray([9,9],[11,9]));
         addGroup(get2DArray([7,17],[12,17]));
         addGroup(get2DArray([14,17],[16,17]));
         addGroup([[4,8],[7,1],[7,7],[3,1],[3,3],[3,6],[7,8],[9,10],[13,10],[8,13],[9,13],[2,15],[6,15],[7,15],[8,15],[9,15],[7,16]]);
         addGroup(get2DArray([1,7],[4,7]));
         addGroup(get2DArray([1,4],[3,4]));
         addGroup(get2DArray([5,2],[5,5]));
         addGroup([[1,15]],"spike",true,270);
         addGroup([[1,15]],"halfWall",true,270);
         addGroup([[2,17]],"spike",true,270);
         addGroup([[2,17]],"halfWall",true,270);
         addGroup([[6,17]],"spike",true,270);
         addGroup([[6,17]],"halfWall",true,270);
         addGroup([[12,9]],"spike",true,90);
         addGroup([[12,9]],"halfWall",true,90);
         addGroup([[14,9]],"spike",true,90);
         addGroup([[14,9]],"halfWall",true,90);
         addGroup([[16,9]],"spike",true,90);
         addGroup([[16,9]],"halfWall",true,90);
         addGroup([[5,8]],"spike",true,180);
         addGroup([[5,8]],"halfWall",true,180);
         addGroup([[9,14],[10,14],[11,14],[12,14],[13,14],[15,14],[15,12],[11,12],[13,12],[9,12],[7,12],[7,10],[14,14],[15,13],[15,11],[14,12],[12,12],[11,11],[10,12],[7,9],[7,11],[7,13],[8,10],[8,12]],"piston",false);
         addGroup([[4,2],[4,3],[4,4],[4,5]],"piston",false);
         addGroup([[8,11]],"key",false);
         addGroup([[9,16]],"door",true);
         addGroup([[8,16]],"key",false);
         addGroup([[8,14]],"door",true);
         addGroup([[6,16]],"key",false);
         addGroup([[4,17]],"door",true,90);
         addGroup([[2,3]],"key",false);
         addGroup([[3,5]],"door",true);
         addGroup([[1,5]],"key",false);
         addGroup([[8,4]],"door",true);
         addGroup([[1,3]],"book",false,3);
         addGroup([[9,4]],"exit",true,"B0");
         addGroup([[4,18]],"exit",true,"R1");
         addGroup([[13,18]],"exit",true,"R2");
         setManPosition([[7,4],[4,16],[13,16]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup([[12,0],[14,0],[17,0],[17,1],[17,4]]);
         addGroup(get2DArray([0,0],[0,15]));
         addGroup(get2DArray([17,6],[17,12]));
         addGroup(get2DArray([17,14],[17,17]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[9,0]));
         addGroup(get2DArray([0,17],[16,17]));
         addGroup([[8,12],[4,14],[4,15],[9,2],[9,5],[9,6],[10,6],[14,6],[15,6],[5,3],[1,6],[6,1]]);
         addGroup([[11,4],[13,3],[14,5],[15,2],[16,4],[12,9],[13,11],[14,14],[2,15],[1,11],[12,15]]);
         addGroup(get2DArray([6,3],[6,8]));
         addGroup(get2DArray([2,8],[5,8]));
         addGroup(get2DArray([14,9],[16,9]));
         addGroup(get2DArray([11,9],[11,16]));
         addGroup(get2DArray([3,11],[8,11]));
         addGroup(get2DArray([12,12],[14,12]));
         addGroup(get2DArray([6,13],[8,13]));
         addGroup(get2DArray([1,13],[4,13]));
         addGroup(get2DArray([4,15],[8,15]));
         addGroup(get2DArray([14,15],[16,15]));
         addGroup([[17,2]],"spike",true,0);
         addGroup([[17,2]],"halfWall",true,0);
         addGroup([[17,3]],"spike",true,0);
         addGroup([[17,3]],"halfWall",true,0);
         addGroup([[17,5]],"spike",true,0);
         addGroup([[17,5]],"halfWall",true,0);
         addGroup([[2,16]],"spike",true,0);
         addGroup([[2,16]],"halfWall",true,0);
         addGroup([[10,0]],"spike",true,90);
         addGroup([[10,0]],"halfWall",true,90);
         addGroup([[11,0]],"spike",true,90);
         addGroup([[11,0]],"halfWall",true,90);
         addGroup([[15,0]],"spike",true,90);
         addGroup([[15,0]],"halfWall",true,90);
         addGroup([[16,0]],"spike",true,90);
         addGroup([[16,0]],"halfWall",true,90);
         addGroup([[9,3]],"spike",true,180);
         addGroup([[9,3]],"halfWall",true,180);
         addGroup([[9,4]],"spike",true,180);
         addGroup([[9,4]],"halfWall",true,180);
         addGroup([[0,16]],"spike",true,180);
         addGroup([[0,16]],"halfWall",true,180);
         addGroup([[11,6]],"spike",true,270);
         addGroup([[11,6]],"halfWall",true,270);
         addGroup([[12,6]],"spike",true,270);
         addGroup([[12,6]],"halfWall",true,270);
         addGroup([[13,6]],"spike",true,270);
         addGroup([[13,6]],"halfWall",true,270);
         addGroup([[7,3],[7,4],[7,5],[7,6],[7,7],[7,8],[8,3],[8,4],[8,5],[8,6],[8,7],[8,8]],"piston",false);
         addGroup([[3,9],[4,9],[5,9],[6,9],[7,9],[8,9],[3,10],[4,10],[5,10],[6,10],[7,10],[8,10]],"piston",false);
         addGroup([[9,7],[10,7],[11,7],[12,7],[13,7],[14,7],[9,8],[10,8],[11,8],[12,8],[13,8],[14,8]],"piston",false);
         addGroup([[9,9],[9,14],[10,9],[10,10],[10,13],[10,14],[9,10],[9,13],[10,11],[10,12]],"piston",false);
         addGroup([[1,1],[1,2],[1,3],[1,4],[2,2],[2,3],[2,4],[3,3],[3,4],[2,1],[3,2]],"piston",false);
         addGroup([[16,16]],"key",false);
         addGroup([[9,1]],"door",true);
         addGroup([[10,5]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[9,12]],"key",false);
         addGroup([[17,13]],"door",true);
         addGroup([[1,16]],"book",false,14);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[13,-1]],"exit",true,"L1");
         addGroup([[18,13]],"exit",true,"B2");
         setManPosition([[4,1],[13,1],[16,13]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,9);
         addGroup(get2DArray([0,0],[0,17]));
         addGroup(get2DArray([8,0],[8,17]));
         addGroup(get2DArray([1,17],[3,17]));
         addGroup(get2DArray([5,17],[7,17]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup([[1,13],[2,0],[3,0],[4,3],[7,2],[7,12],[6,10],[7,5],[7,10],[3,14],[4,14],[7,14],[7,15],[2,16],[7,16],[6,16]]);
         addGroup(get2DArray([2,8],[2,14]));
         addGroup(get2DArray([2,2],[4,2]));
         addGroup([[1,0]],"spike",true,90);
         addGroup([[1,0]],"halfWall",true,90);
         addGroup([[5,2]],"spike",true,90);
         addGroup([[5,2]],"halfWall",true,90);
         addGroup([[6,2]],"spike",true,90);
         addGroup([[6,2]],"halfWall",true,90);
         addGroup([[7,3]],"spike",true,0);
         addGroup([[7,3]],"halfWall",true,0);
         addGroup([[7,6]],"spike",true,0);
         addGroup([[7,6]],"halfWall",true,0);
         addGroup([[7,7]],"spike",true,0);
         addGroup([[7,7]],"halfWall",true,0);
         addGroup([[7,8]],"spike",true,0);
         addGroup([[7,8]],"halfWall",true,0);
         addGroup([[7,9]],"spike",true,0);
         addGroup([[7,9]],"halfWall",true,0);
         addGroup([[7,13]],"spike",true,0);
         addGroup([[7,13]],"halfWall",true,0);
         addGroup([[1,1],[1,3],[1,4],[2,3],[3,3],[1,2]],"piston",false);
         addGroup([[1,7],[1,8],[1,9],[1,10],[2,7]],"piston",false);
         addGroup([[7,1]],"key",false);
         addGroup([[2,15]],"door",true);
         addGroup([[1,14]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[4,18]],"exit",true,"R1");
         setManPosition([[5,1],[4,16]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,3]));
         addGroup(get2DArray([0,5],[0,8]));
         addGroup(get2DArray([8,0],[8,8]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,8],[7,8]));
         addGroup([[1,2],[1,6],[3,2],[4,2],[6,2],[7,2],[4,4],[6,4],[7,4],[6,5],[5,7],[6,7]]);
         addGroup(get2DArray([3,4],[3,6]));
         addGroup([[4,3],[5,3],[6,3]],"piston",false);
         addGroup([[5,4],[5,5],[5,6]],"piston",false);
         addGroup([[7,1]],"key",false);
         addGroup([[3,3]],"door",true);
         addGroup([[7,7]],"key",false);
         addGroup([[5,2]],"door",true,90);
         addGroup([[7,3]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[-1,4]],"exit",true,"T1");
         setManPosition([[4,1],[1,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,9);
         addGroup(get2DArray([0,0],[0,3]));
         addGroup(get2DArray([0,5],[0,17]));
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([8,5],[8,17]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,17],[7,17]));
         addGroup([[1,6],[5,15],[2,16],[7,12],[4,10],[4,11],[6,6],[6,7],[1,13],[2,13],[2,14],[3,14],[2,1],[2,2],[6,1],[6,2]]);
         addGroup(get2DArray([3,2],[3,8]));
         addGroup(get2DArray([5,2],[5,4]));
         addGroup([[2,8]],"spike",true,0);
         addGroup([[2,8]],"halfWall",true,0);
         addGroup([[4,8]],"spike",true,180);
         addGroup([[4,8]],"halfWall",true,180);
         addGroup([[1,12]],"spike",true,270);
         addGroup([[1,12]],"halfWall",true,270);
         addGroup([[4,0]],"spike",true,90);
         addGroup([[4,0]],"halfWall",true,90);
         addGroup([[7,7]],"spike",true,90);
         addGroup([[7,7]],"halfWall",true,90);
         addGroup([[1,15],[2,15]],"piston",false);
         addGroup([[6,9],[1,9],[2,9],[3,9],[4,9],[5,9],[6,10],[1,10]],"piston",false);
         addGroup([[1,14]],"key",false);
         addGroup([[4,3]],"door",true,90);
         addGroup([[5,1]],"key",false);
         addGroup([[8,4]],"door",true);
         addGroup([[-1,4]],"exit",true,"T0");
         addGroup([[9,4]],"exit",true,"B1");
         setManPosition([[1,4],[7,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup([[3,17],[17,3],[0,3],[5,0],[17,6],[17,7],[17,15],[14,17],[15,17],[6,0],[8,0],[9,0],[14,0],[15,0],[11,0],[12,0],[0,0],[0,6],[0,7],[0,11],[0,12],[0,14],[0,15],[0,17],[6,17],[10,17],[17,0],[17,12],[11,17],[17,17],[2,0],[3,0]]);
         addGroup([[13,4],[6,2],[4,11],[4,14],[15,4],[2,4],[4,4],[6,4],[11,3],[11,4],[4,12],[4,15],[1,15],[3,15],[16,12],[2,1],[2,3],[2,9],[4,5],[5,12],[8,7],[8,15],[10,3],[10,10],[12,13],[13,5],[15,9],[15,1],[15,3]]);
         addGroup([[0,1]],"spike",true,180);
         addGroup([[0,1]],"halfWall",true,180);
         addGroup([[0,2]],"spike",true,180);
         addGroup([[0,2]],"halfWall",true,180);
         addGroup([[0,4]],"spike",true,180);
         addGroup([[0,4]],"halfWall",true,180);
         addGroup([[0,5]],"spike",true,180);
         addGroup([[0,5]],"halfWall",true,180);
         addGroup([[0,8]],"spike",true,180);
         addGroup([[0,8]],"halfWall",true,180);
         addGroup([[0,9]],"spike",true,180);
         addGroup([[0,9]],"halfWall",true,180);
         addGroup([[0,10]],"spike",true,180);
         addGroup([[0,10]],"halfWall",true,180);
         addGroup([[0,16]],"spike",true,180);
         addGroup([[0,16]],"halfWall",true,180);
         addGroup([[4,13]],"spike",true,180);
         addGroup([[4,13]],"halfWall",true,180);
         addGroup([[6,1]],"spike",true,180);
         addGroup([[6,1]],"halfWall",true,180);
         addGroup([[6,3]],"spike",true,180);
         addGroup([[6,3]],"halfWall",true,180);
         addGroup([[11,1]],"spike",true,0);
         addGroup([[11,1]],"halfWall",true,0);
         addGroup([[11,2]],"spike",true,0);
         addGroup([[11,2]],"halfWall",true,0);
         addGroup([[17,1]],"spike",true,0);
         addGroup([[17,1]],"halfWall",true,0);
         addGroup([[17,2]],"spike",true,0);
         addGroup([[17,2]],"halfWall",true,0);
         addGroup([[17,4]],"spike",true,0);
         addGroup([[17,4]],"halfWall",true,0);
         addGroup([[17,5]],"spike",true,0);
         addGroup([[17,5]],"halfWall",true,0);
         addGroup([[17,8]],"spike",true,0);
         addGroup([[17,8]],"halfWall",true,0);
         addGroup([[17,9]],"spike",true,0);
         addGroup([[17,9]],"halfWall",true,0);
         addGroup([[17,10]],"spike",true,0);
         addGroup([[17,10]],"halfWall",true,0);
         addGroup([[17,11]],"spike",true,0);
         addGroup([[17,11]],"halfWall",true,0);
         addGroup([[17,13]],"spike",true,0);
         addGroup([[17,13]],"halfWall",true,0);
         addGroup([[17,14]],"spike",true,0);
         addGroup([[17,14]],"halfWall",true,0);
         addGroup([[17,16]],"spike",true,0);
         addGroup([[17,16]],"halfWall",true,0);
         addGroup([[1,0]],"spike",true,90);
         addGroup([[1,0]],"halfWall",true,90);
         addGroup([[7,0]],"spike",true,90);
         addGroup([[7,0]],"halfWall",true,90);
         addGroup([[10,0]],"spike",true,90);
         addGroup([[10,0]],"halfWall",true,90);
         addGroup([[16,0]],"spike",true,90);
         addGroup([[16,0]],"halfWall",true,90);
         addGroup([[3,4]],"spike",true,90);
         addGroup([[3,4]],"halfWall",true,90);
         addGroup([[5,4]],"spike",true,90);
         addGroup([[5,4]],"halfWall",true,90);
         addGroup([[12,4]],"spike",true,90);
         addGroup([[12,4]],"halfWall",true,90);
         addGroup([[14,4]],"spike",true,90);
         addGroup([[14,4]],"halfWall",true,90);
         addGroup([[1,11]],"spike",true,270);
         addGroup([[1,11]],"halfWall",true,270);
         addGroup([[2,11]],"spike",true,270);
         addGroup([[2,11]],"halfWall",true,270);
         addGroup([[3,11]],"spike",true,270);
         addGroup([[3,11]],"halfWall",true,270);
         addGroup([[1,17]],"spike",true,270);
         addGroup([[1,17]],"halfWall",true,270);
         addGroup([[2,17]],"spike",true,270);
         addGroup([[2,17]],"halfWall",true,270);
         addGroup([[4,17]],"spike",true,270);
         addGroup([[4,17]],"halfWall",true,270);
         addGroup([[5,17]],"spike",true,270);
         addGroup([[5,17]],"halfWall",true,270);
         addGroup([[7,17]],"spike",true,270);
         addGroup([[7,17]],"halfWall",true,270);
         addGroup([[8,17]],"spike",true,270);
         addGroup([[8,17]],"halfWall",true,270);
         addGroup([[9,17]],"spike",true,270);
         addGroup([[9,17]],"halfWall",true,270);
         addGroup([[12,17]],"spike",true,270);
         addGroup([[12,17]],"halfWall",true,270);
         addGroup([[13,17]],"spike",true,270);
         addGroup([[13,17]],"halfWall",true,270);
         addGroup([[16,17]],"spike",true,270);
         addGroup([[16,17]],"halfWall",true,270);
         addGroup([[7,8],[6,8],[8,8],[7,7],[7,9]],"piston",false);
         addGroup([[5,3]],"key",false);
         addGroup([[13,0]],"door",true,90);
         addGroup([[12,3]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[13,-1]],"exit",true,"L1");
         addGroup([[-1,13]],"exit",true,"T2");
         setManPosition([[5,1],[13,1],[1,13]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,8]));
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([8,5],[8,8]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,8],[3,8]));
         addGroup(get2DArray([5,8],[7,8]));
         addGroup([[1,2]]);
         addGroup([[1,5],[2,5],[3,5],[4,5],[1,6]],"piston",false);
         addGroup([[3,1],[3,2],[3,3],[3,4],[2,1]],"piston",false);
         addGroup([[7,3],[4,3],[5,3],[6,3],[7,2]],"piston",false);
         addGroup([[5,7],[5,4],[5,5],[5,6],[6,7]],"piston",false);
         addGroup([[2,2]],"key",false);
         addGroup([[8,4]],"door",true);
         addGroup([[4,4]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[4,9]],"exit",true,"R1");
         addGroup([[9,4]],"exit",true,"B2");
         setManPosition([[4,1],[4,7],[7,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup([[7,9],[11,17],[12,17]]);
         addGroup(get2DArray([0,9],[0,12]));
         addGroup(get2DArray([0,14],[0,17]));
         addGroup(get2DArray([9,0],[9,8]));
         addGroup(get2DArray([17,0],[17,12]));
         addGroup(get2DArray([17,14],[17,17]));
         addGroup(get2DArray([1,9],[3,9]));
         addGroup(get2DArray([9,0],[16,0]));
         addGroup(get2DArray([3,17],[4,17]));
         addGroup(get2DArray([14,17],[16,17]));
         addGroup([[1,14],[3,11],[11,4],[16,11],[16,15],[2,14],[5,13],[13,13],[3,15],[7,15],[14,15],[14,16],[9,13],[11,10],[12,7]]);
         addGroup(get2DArray([10,11],[14,11]));
         addGroup(get2DArray([13,2],[13,7]));
         addGroup(get2DArray([11,6],[11,8]));
         addGroup([[7,10]],"spike",true,0);
         addGroup([[7,10]],"halfWall",true,0);
         addGroup([[7,11]],"spike",true,0);
         addGroup([[7,11]],"halfWall",true,0);
         addGroup([[7,12]],"spike",true,0);
         addGroup([[7,12]],"halfWall",true,0);
         addGroup([[11,9]],"spike",true,0);
         addGroup([[11,9]],"halfWall",true,0);
         addGroup([[11,12]],"spike",true,0);
         addGroup([[11,12]],"halfWall",true,0);
         addGroup([[11,13]],"spike",true,0);
         addGroup([[11,13]],"halfWall",true,0);
         addGroup([[11,14]],"spike",true,0);
         addGroup([[11,14]],"halfWall",true,0);
         addGroup([[11,15]],"spike",true,0);
         addGroup([[11,15]],"halfWall",true,0);
         addGroup([[11,16]],"spike",true,0);
         addGroup([[11,16]],"halfWall",true,0);
         addGroup([[4,9]],"spike",true,90);
         addGroup([[4,9]],"halfWall",true,90);
         addGroup([[5,9]],"spike",true,90);
         addGroup([[5,9]],"halfWall",true,90);
         addGroup([[6,9]],"spike",true,90);
         addGroup([[6,9]],"halfWall",true,90);
         addGroup([[8,9]],"spike",true,90);
         addGroup([[8,9]],"halfWall",true,90);
         addGroup([[9,9]],"spike",true,90);
         addGroup([[9,9]],"halfWall",true,90);
         addGroup([[3,10]],"spike",true,180);
         addGroup([[3,10]],"halfWall",true,180);
         addGroup([[3,14]],"spike",true,180);
         addGroup([[3,14]],"halfWall",true,180);
         addGroup([[1,17]],"spike",true,270);
         addGroup([[1,17]],"halfWall",true,270);
         addGroup([[2,17]],"spike",true,270);
         addGroup([[2,17]],"halfWall",true,270);
         addGroup([[5,17]],"spike",true,270);
         addGroup([[5,17]],"halfWall",true,270);
         addGroup([[6,17]],"spike",true,270);
         addGroup([[6,17]],"halfWall",true,270);
         addGroup([[7,17]],"spike",true,270);
         addGroup([[7,17]],"halfWall",true,270);
         addGroup([[8,17]],"spike",true,270);
         addGroup([[8,17]],"halfWall",true,270);
         addGroup([[9,17]],"spike",true,270);
         addGroup([[9,17]],"halfWall",true,270);
         addGroup([[10,17]],"spike",true,270);
         addGroup([[10,17]],"halfWall",true,270);
         addGroup([[10,1],[11,1],[12,1]],"piston",false);
         addGroup([[10,2],[11,2],[12,2]],"piston",false);
         addGroup([[10,3],[11,3],[12,3]],"piston",false);
         addGroup([[13,14],[15,14],[15,12],[14,14],[15,13]],"piston",false);
         addGroup([[2,15]],"key",false);
         addGroup([[10,8]],"door",true,90);
         addGroup([[12,6]],"key",false);
         addGroup([[13,1]],"door",true);
         addGroup([[-1,13]],"exit",true,"T0");
         addGroup([[18,13]],"exit",true,"B1");
         addGroup([[13,18]],"exit",true,"R2");
         setManPosition([[1,13],[16,13],[13,16]]);
         addGroup([[14,14]],"man",false);
         createRoom(9,9);
         addGroup([[0,0],[0,2],[0,3],[0,5],[8,8],[2,0],[3,0],[5,0],[6,0]]);
         addGroup(get2DArray([8,0],[8,6]));
         addGroup(get2DArray([0,8],[2,8]));
         addGroup(get2DArray([4,8],[6,8]));
         addGroup([[2,7]]);
         addGroup([[8,7]],"spike",true,0);
         addGroup([[8,7]],"halfWall",true,0);
         addGroup([[1,0]],"spike",true,90);
         addGroup([[1,0]],"halfWall",true,90);
         addGroup([[7,0]],"spike",true,90);
         addGroup([[7,0]],"halfWall",true,90);
         addGroup([[0,1]],"spike",true,180);
         addGroup([[0,1]],"halfWall",true,180);
         addGroup([[0,6]],"spike",true,180);
         addGroup([[0,6]],"halfWall",true,180);
         addGroup([[0,7]],"spike",true,180);
         addGroup([[0,7]],"halfWall",true,180);
         addGroup([[3,8]],"spike",true,270);
         addGroup([[3,8]],"halfWall",true,270);
         addGroup([[7,8]],"spike",true,270);
         addGroup([[7,8]],"halfWall",true,270);
         addGroup([[2,2],[1,2],[3,2],[2,1],[2,3]],"piston",false);
         addGroup([[3,6],[3,5],[3,7],[4,6],[2,6]],"piston",false);
         addGroup([[6,4],[6,3],[6,5],[5,4],[7,4]],"piston",false);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[-1,4]],"exit",true,"T1");
         setManPosition([[4,1],[1,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup([[17,6]]);
         addGroup(get2DArray([0,9],[0,12]));
         addGroup(get2DArray([0,14],[0,17]));
         addGroup(get2DArray([9,0],[9,9]));
         addGroup(get2DArray([17,0],[17,2]));
         addGroup(get2DArray([17,10],[17,12]));
         addGroup(get2DArray([17,14],[17,17]));
         addGroup(get2DArray([1,9],[8,9]));
         addGroup(get2DArray([9,0],[12,0]));
         addGroup(get2DArray([14,0],[16,0]));
         addGroup(get2DArray([1,17],[16,17]));
         addGroup([[13,12],[1,14],[2,14],[3,10],[3,11],[2,13],[3,13],[7,12],[9,12],[9,13],[11,12],[10,7],[10,8],[12,3],[12,6],[12,7]]);
         addGroup([[16,2],[14,4],[15,4],[15,6],[16,6],[14,8],[11,1],[14,1],[14,12],[15,10],[16,10],[16,12],[16,15]]);
         addGroup(get2DArray([11,3],[14,3]));
         addGroup([[14,14]],"spike",true,0);
         addGroup([[14,14]],"halfWall",true,0);
         addGroup([[14,15]],"spike",true,0);
         addGroup([[14,15]],"halfWall",true,0);
         addGroup([[14,16]],"spike",true,0);
         addGroup([[14,16]],"halfWall",true,0);
         addGroup([[17,3]],"spike",true,0);
         addGroup([[17,3]],"halfWall",true,0);
         addGroup([[17,4]],"spike",true,0);
         addGroup([[17,4]],"halfWall",true,0);
         addGroup([[17,5]],"spike",true,0);
         addGroup([[17,5]],"halfWall",true,0);
         addGroup([[17,7]],"spike",true,0);
         addGroup([[17,7]],"halfWall",true,0);
         addGroup([[17,8]],"spike",true,0);
         addGroup([[17,8]],"halfWall",true,0);
         addGroup([[17,9]],"spike",true,0);
         addGroup([[17,9]],"halfWall",true,0);
         addGroup([[5,12]],"spike",true,90);
         addGroup([[5,12]],"halfWall",true,90);
         addGroup([[7,13]],"spike",true,90);
         addGroup([[7,13]],"halfWall",true,90);
         addGroup([[9,14]],"spike",true,90);
         addGroup([[9,14]],"halfWall",true,90);
         addGroup([[11,13]],"spike",true,90);
         addGroup([[11,13]],"halfWall",true,90);
         addGroup([[4,15]],"spike",true,180);
         addGroup([[4,15]],"halfWall",true,180);
         addGroup([[4,16]],"spike",true,180);
         addGroup([[4,16]],"halfWall",true,180);
         addGroup([[11,6],[11,4],[13,4],[13,5],[13,6],[13,7],[13,9],[12,9],[11,5],[12,4],[13,8]],"piston",false);
         addGroup([[11,8],[12,8],[11,9],[10,9]],"piston",false);
         addGroup([[4,10],[6,10],[8,10],[10,10],[12,10],[13,10],[4,11],[6,11],[6,12],[8,11],[8,12],[8,13],[10,11],[10,12],[10,13],[12,11],[12,12],[5,10],[7,10],[9,10],[11,10]],"piston",false);
         addGroup([[13,11]],"key",false);
         addGroup([[11,2]],"door",true);
         addGroup([[10,1]],"key",false);
         addGroup([[11,7]],"door",true,90);
         addGroup([[13,-1]],"exit",true,"L0");
         addGroup([[-1,13]],"exit",true,"T1");
         addGroup([[18,13]],"exit",true,"B2");
         setManPosition([[13,1],[1,12],[16,13]]);
         addGroup([[14,14]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,3]));
         addGroup(get2DArray([0,5],[0,8]));
         addGroup(get2DArray([8,0],[8,8]));
         addGroup(get2DArray([1,0],[7,0]));
         addGroup(get2DArray([1,8],[3,8]));
         addGroup(get2DArray([5,8],[7,8]));
         addGroup([[2,2],[4,5],[6,3],[6,4],[6,6],[6,7]]);
         addGroup(get2DArray([2,4],[4,4]));
         addGroup(get2DArray([2,5],[2,7]));
         addGroup(get2DArray([4,2],[6,2]));
         addGroup([[1,3]],"key",false);
         addGroup([[1,2]],"door",true,90);
         addGroup([[1,1]],"key",false);
         addGroup([[2,1]],"door",true);
         addGroup([[3,1]],"key",false);
         addGroup([[5,1]],"door",true);
         addGroup([[6,1]],"key",false);
         addGroup([[1,6]],"door",true,90);
         addGroup([[7,2]],"key",false);
         addGroup([[3,2]],"door",true,90);
         addGroup([[1,7]],"key",false);
         addGroup([[7,3]],"door",true,90);
         addGroup([[7,4]],"key",false);
         addGroup([[7,6]],"door",true,90);
         addGroup([[7,7]],"key",false);
         addGroup([[6,5]],"door",true);
         addGroup([[3,5]],"key",false);
         addGroup([[5,4]],"door",true,90);
         addGroup([[5,3]],"key",false);
         addGroup([[4,3]],"door",true);
         addGroup([[3,3]],"key",false);
         addGroup([[2,3]],"door",true);
         addGroup([[-1,4]],"exit",true,"T0");
         addGroup([[4,9]],"exit",true,"R1");
         setManPosition([[1,4],[4,7]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup([[17,5],[0,7],[0,8],[0,11],[0,12],[1,0],[9,0],[11,0],[12,0]]);
         addGroup(get2DArray([0,0],[0,2]));
         addGroup(get2DArray([0,14],[0,17]));
         addGroup(get2DArray([17,0],[17,2]));
         addGroup(get2DArray([17,9],[17,17]));
         addGroup(get2DArray([14,0],[16,0]));
         addGroup(get2DArray([1,17],[16,17]));
         addGroup([[8,8]]);
         addGroup([[11,1],[2,8],[15,1],[11,2],[15,7],[16,9],[14,12],[13,13],[12,14],[11,16],[14,11],[16,11],[2,2],[2,4]]);
         addGroup([[5,0],[5,14],[5,16],[14,5],[14,7],[14,9],[3,2],[1,11],[2,11],[1,15],[7,15],[16,1],[16,5],[5,2],[9,2]]);
         addGroup(get2DArray([11,3],[15,3]));
         addGroup(get2DArray([10,14],[10,16]));
         addGroup(get2DArray([3,13],[3,15]));
         addGroup([[2,6]],"spike",true,0);
         addGroup([[2,6]],"halfWall",true,0);
         addGroup([[2,7]],"spike",true,0);
         addGroup([[2,7]],"halfWall",true,0);
         addGroup([[17,3]],"spike",true,0);
         addGroup([[17,3]],"halfWall",true,0);
         addGroup([[17,4]],"spike",true,0);
         addGroup([[17,4]],"halfWall",true,0);
         addGroup([[17,6]],"spike",true,0);
         addGroup([[17,6]],"halfWall",true,0);
         addGroup([[17,7]],"spike",true,0);
         addGroup([[17,7]],"halfWall",true,0);
         addGroup([[17,8]],"spike",true,0);
         addGroup([[17,8]],"halfWall",true,0);
         addGroup([[14,4]],"spike",true,0);
         addGroup([[14,4]],"halfWall",true,0);
         addGroup([[14,6]],"spike",true,180);
         addGroup([[14,6]],"halfWall",true,180);
         addGroup([[14,8]],"spike",true,180);
         addGroup([[14,8]],"halfWall",true,180);
         addGroup([[2,3]],"spike",true,180);
         addGroup([[2,3]],"halfWall",true,180);
         addGroup([[0,3]],"spike",true,180);
         addGroup([[0,3]],"halfWall",true,180);
         addGroup([[0,4]],"spike",true,180);
         addGroup([[0,4]],"halfWall",true,180);
         addGroup([[0,5]],"spike",true,180);
         addGroup([[0,5]],"halfWall",true,180);
         addGroup([[0,6]],"spike",true,180);
         addGroup([[0,6]],"halfWall",true,180);
         addGroup([[0,9]],"spike",true,180);
         addGroup([[0,9]],"halfWall",true,180);
         addGroup([[0,10]],"spike",true,180);
         addGroup([[0,10]],"halfWall",true,180);
         addGroup([[2,0]],"spike",true,90);
         addGroup([[2,0]],"halfWall",true,90);
         addGroup([[3,0]],"spike",true,90);
         addGroup([[3,0]],"halfWall",true,90);
         addGroup([[4,0]],"spike",true,90);
         addGroup([[4,0]],"halfWall",true,90);
         addGroup([[6,0]],"spike",true,90);
         addGroup([[6,0]],"halfWall",true,90);
         addGroup([[7,0]],"spike",true,90);
         addGroup([[7,0]],"halfWall",true,90);
         addGroup([[8,0]],"spike",true,90);
         addGroup([[8,0]],"halfWall",true,90);
         addGroup([[10,0]],"spike",true,90);
         addGroup([[10,0]],"halfWall",true,90);
         addGroup([[6,2]],"spike",true,90);
         addGroup([[6,2]],"halfWall",true,90);
         addGroup([[7,2]],"spike",true,90);
         addGroup([[7,2]],"halfWall",true,90);
         addGroup([[8,2]],"spike",true,90);
         addGroup([[8,2]],"halfWall",true,90);
         addGroup([[9,3]],"spike",true,90);
         addGroup([[9,3]],"halfWall",true,90);
         addGroup([[10,3]],"spike",true,90);
         addGroup([[10,3]],"halfWall",true,90);
         addGroup([[3,4]],"spike",true,180);
         addGroup([[3,4]],"halfWall",true,180);
         addGroup([[3,5]],"spike",true,180);
         addGroup([[3,5]],"halfWall",true,180);
         addGroup([[3,6]],"spike",true,180);
         addGroup([[3,6]],"halfWall",true,180);
         addGroup([[3,8]],"spike",true,180);
         addGroup([[3,8]],"halfWall",true,180);
         addGroup([[3,9]],"spike",true,180);
         addGroup([[3,9]],"halfWall",true,180);
         addGroup([[3,10]],"spike",true,180);
         addGroup([[3,10]],"halfWall",true,180);
         addGroup([[3,11]],"spike",true,180);
         addGroup([[3,11]],"halfWall",true,180);
         addGroup([[3,12]],"spike",true,180);
         addGroup([[3,12]],"halfWall",true,180);
         addGroup([[11,4]],"spike",true,0);
         addGroup([[11,4]],"halfWall",true,0);
         addGroup([[11,5]],"spike",true,90);
         addGroup([[11,5]],"halfWall",true,90);
         addGroup([[12,5]],"spike",true,90);
         addGroup([[12,5]],"halfWall",true,90);
         addGroup([[15,11]],"spike",true,270);
         addGroup([[15,11]],"halfWall",true,270);
         addGroup([[4,13]],"spike",true,270);
         addGroup([[4,13]],"halfWall",true,270);
         addGroup([[5,13]],"spike",true,270);
         addGroup([[5,13]],"halfWall",true,270);
         addGroup([[6,14]],"spike",true,270);
         addGroup([[6,14]],"halfWall",true,270);
         addGroup([[7,14]],"spike",true,270);
         addGroup([[7,14]],"halfWall",true,270);
         addGroup([[8,14]],"spike",true,270);
         addGroup([[8,14]],"halfWall",true,270);
         addGroup([[12,13]],"spike",true,270);
         addGroup([[12,13]],"halfWall",true,270);
         addGroup([[13,7]],"spike",true,0);
         addGroup([[13,7]],"halfWall",true,0);
         addGroup([[13,12]],"spike",true,0);
         addGroup([[13,12]],"halfWall",true,0);
         addGroup([[7,7],[9,7],[9,6],[10,8],[12,8],[12,10],[13,10],[12,12],[8,9],[7,8],[12,9],[12,11],[9,10],[10,12],[11,12],[10,13],[8,10],[9,11],[8,7],[11,8],[10,7],[10,10],[7,9],[9,12]],"piston",false);
         addGroup([[14,15],[14,16],[15,15],[15,16],[16,15],[16,16]],"piston",false);
         addGroup([[12,4]],"key",false);
         addGroup([[4,2]],"door",true,90);
         addGroup([[2,10]],"key",false);
         addGroup([[11,14]],"door",true,90);
         addGroup([[16,12]],"book",false,6);
         addGroup([[13,-1]],"exit",true,"L0");
         addGroup([[-1,13]],"exit",true,"T1");
         setManPosition([[13,1],[1,13]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup(get2DArray([0,0],[0,15]));
         addGroup(get2DArray([17,0],[17,17]));
         addGroup(get2DArray([1,0],[12,0]));
         addGroup(get2DArray([14,0],[16,0]));
         addGroup(get2DArray([0,17],[3,17]));
         addGroup(get2DArray([5,17],[16,17]));
         addGroup([[1,4],[1,5],[1,9]]);
         addGroup([[2,2],[2,4],[2,7],[2,11],[2,13],[2,15]]);
         addGroup([[3,2],[3,6],[3,7],[3,8],[3,10],[3,11],[3,15],[3,16]]);
         addGroup([[4,2],[4,3],[4,4],[4,5],[4,6],[4,8],[4,11],[4,12],[4,13]]);
         addGroup([[5,2],[5,4],[5,8],[5,9],[5,11],[5,13],[5,14],[5,15],[5,16]]);
         addGroup([[6,4],[6,6],[6,11],[6,15]]);
         addGroup([[7,1],[7,2],[7,4],[7,6],[7,7],[7,8],[7,9],[7,10],[7,11],[7,13],[7,15]]);
         addGroup([[8,2],[8,4],[8,8],[8,13]]);
         addGroup([[9,4],[9,5],[9,6],[9,8],[9,10],[9,11],[9,12],[9,13],[9,14],[9,16]]);
         addGroup([[10,2],[10,4],[10,6],[10,10],[10,12]]);
         addGroup([[11,6],[11,8],[11,10],[11,14],[11,15]]);
         addGroup([[12,1],[12,2],[12,3],[12,4],[12,8],[12,12],[12,13],[12,14]]);
         addGroup([[13,4],[13,5],[13,6],[13,7],[13,8],[13,10],[13,11],[13,12],[13,16]]);
         addGroup([[14,1],[14,2],[14,4],[14,8],[14,9],[14,10],[14,12],[14,14]]);
         addGroup([[15,4],[15,6],[15,8],[15,12],[15,13],[15,14],[15,15]]);
         addGroup([[16,2],[16,6],[16,10]]);
         addGroup([[0,16]],"spike",true,180);
         addGroup([[0,16]],"halfWall",true,180);
         addGroup([[1,13]],"spike",true,90);
         addGroup([[1,13]],"halfWall",true,90);
         addGroup([[7,3]],"spike",true,0);
         addGroup([[7,3]],"halfWall",true,0);
         addGroup([[10,3]],"spike",true,0);
         addGroup([[10,3]],"halfWall",true,0);
         addGroup([[11,9]],"spike",true,180);
         addGroup([[11,9]],"halfWall",true,180);
         addGroup([[13,9]],"key",false);
         addGroup([[13,2]],"door",true,90);
         addGroup([[8,3]],"key",false);
         addGroup([[1,2]],"door",true,90);
         addGroup([[5,3]],"key",false);
         addGroup([[13,0]],"door",true,90);
         addGroup([[2,16]],"wind",false);
         addGroup([[1,16]],"book",false,7);
         addGroup([[13,-1]],"exit",true,"L0");
         addGroup([[4,18]],"exit",true,"R1");
         setManPosition([[13,1],[4,16]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,8]));
         addGroup(get2DArray([8,0],[8,8]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,8],[3,8]));
         addGroup(get2DArray([5,8],[7,8]));
         addGroup([[7,2],[1,7],[7,6],[2,2]]);
         addGroup(get2DArray([5,4],[7,4]));
         addGroup([[1,2]],"spike",true,90);
         addGroup([[1,2]],"halfWall",true,90);
         addGroup([[6,3],[5,3],[4,3],[3,3]],"piston",false);
         addGroup([[3,4],[2,4],[1,4]],"piston",false);
         addGroup([[4,5],[3,5],[2,5],[1,5]],"piston",false);
         addGroup([[2,6],[1,6]],"piston",false);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[4,9]],"exit",true,"R1");
         setManPosition([[4,1],[4,7]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup(get2DArray([0,0],[0,3]));
         addGroup(get2DArray([0,5],[0,17]));
         addGroup(get2DArray([17,0],[17,3]));
         addGroup(get2DArray([17,5],[17,17]));
         addGroup(get2DArray([1,0],[16,0]));
         addGroup(get2DArray([1,17],[3,17]));
         addGroup(get2DArray([5,17],[16,17]));
         addGroup([[1,12],[2,15],[6,16],[5,12],[3,13],[12,16],[11,1],[11,2],[12,2],[12,4],[13,4],[15,2]]);
         addGroup([[1,2],[1,6],[3,6],[3,7],[5,3],[5,5],[12,12],[14,10],[13,14],[14,16],[16,13]]);
         addGroup(get2DArray([6,1],[6,3]));
         addGroup(get2DArray([6,5],[6,8]));
         addGroup(get2DArray([1,8],[5,8]));
         addGroup(get2DArray([1,11],[3,11]));
         addGroup(get2DArray([5,11],[8,11]));
         addGroup(get2DArray([8,12],[8,16]));
         addGroup(get2DArray([11,9],[11,12]));
         addGroup(get2DArray([11,14],[11,16]));
         addGroup(get2DArray([12,9],[16,9]));
         addGroup(get2DArray([9,1],[9,6]));
         addGroup(get2DArray([10,6],[12,6]));
         addGroup(get2DArray([14,6],[16,6]));
         addGroup(get2DArray([14,2],[14,5]));
         addGroup(get2DArray([3,1],[3,4]));
         addGroup(get2DArray([2,14],[6,14]));
         addGroup(get2DArray([14,12],[14,14]));
         addGroup([[7,3],[8,3],[8,4],[8,5],[8,6],[8,7],[8,8],[7,4]],"piston",false);
         addGroup([[14,7],[9,8],[10,8],[11,8],[13,8],[13,7],[14,8],[12,8]],"piston",false);
         addGroup([[3,9],[4,9],[5,9],[6,9],[7,9],[8,9],[3,10],[4,10]],"piston",false);
         addGroup([[9,9],[9,10],[9,11],[9,14],[10,14],[9,13],[10,13],[9,12]],"piston",false);
         addGroup([[15,11],[15,12],[15,13],[15,14],[15,15]],"piston",false);
         addGroup([[16,12]],"key",false);
         addGroup([[0,4]],"door",true);
         addGroup([[16,14]],"key",false);
         addGroup([[5,4]],"door",true);
         addGroup([[5,2]],"key",false);
         addGroup([[17,4]],"door",true);
         addGroup([[-1,4]],"exit",true,"T0");
         addGroup([[4,18]],"exit",true,"R1");
         addGroup([[18,4]],"exit",true,"B2");
         setManPosition([[1,4],[4,16],[16,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,2],[0,8]));
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([8,5],[8,8]));
         addGroup(get2DArray([0,0],[7,0]));
         addGroup(get2DArray([1,8],[7,8]));
         addGroup([[2,2],[3,2],[3,3],[4,5],[7,6]]);
         addGroup(get2DArray([2,6],[4,6]));
         addGroup(get2DArray([5,2],[7,2]));
         addGroup(get2DArray([5,3],[5,5]));
         addGroup([[0,1]],"spike",true,180);
         addGroup([[0,1]],"halfWall",true,180);
         addGroup([[3,1]],"spike",true,180);
         addGroup([[3,1]],"halfWall",true,180);
         addGroup([[2,4],[2,5],[3,4],[3,5]],"piston",false);
         addGroup([[5,1]],"key",false);
         addGroup([[1,2]],"door",true,90);
         addGroup([[2,1]],"book",false,12);
         addGroup([[9,4]],"exit",true,"B0");
         setManPosition([[7,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,9);
         addGroup(get2DArray([0,0],[0,12]));
         addGroup(get2DArray([0,14],[0,17]));
         addGroup(get2DArray([8,0],[8,17]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,17],[3,17]));
         addGroup(get2DArray([5,17],[7,17]));
         addGroup([[7,7],[1,7],[2,1],[4,2],[6,1],[1,9],[2,9],[4,12],[4,13],[7,11]]);
         addGroup([[5,16],[3,13],[3,14],[2,14],[2,16]]);
         addGroup(get2DArray([2,3],[7,3]));
         addGroup(get2DArray([1,5],[2,5]));
         addGroup(get2DArray([4,5],[7,5]));
         addGroup(get2DArray([3,7],[5,7]));
         addGroup(get2DArray([5,9],[7,9]));
         addGroup(get2DArray([1,11],[5,11]));
         addGroup(get2DArray([6,13],[6,16]));
         addGroup([[5,4],[6,4],[7,4]],"piston",false);
         addGroup([[2,6],[3,6],[4,6],[5,6]],"piston",false);
         addGroup([[4,8],[5,8],[6,8],[7,8]],"piston",false);
         addGroup([[5,10],[6,10],[7,10]],"piston",false);
         addGroup([[6,6],[6,7]],"piston",false);
         addGroup([[3,12]],"key",false);
         addGroup([[4,17]],"door",true,90);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[-1,13]],"exit",true,"T1");
         addGroup([[4,18]],"exit",true,"R2");
         setManPosition([[4,1],[1,14],[4,16]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,18);
         addGroup([[14,8]]);
         addGroup(get2DArray([0,0],[0,8]));
         addGroup(get2DArray([17,0],[17,3]));
         addGroup(get2DArray([17,5],[17,8]));
         addGroup(get2DArray([1,0],[12,0]));
         addGroup(get2DArray([14,0],[16,0]));
         addGroup(get2DArray([1,8],[12,8]));
         addGroup([[12,1],[12,3],[12,7],[7,3],[9,3],[3,3],[3,5],[4,5],[14,3],[14,4],[15,1],[15,3],[14,6]]);
         addGroup(get2DArray([12,5],[16,5]));
         addGroup(get2DArray([7,5],[9,5]));
         addGroup(get2DArray([5,3],[5,5]));
         addGroup([[7,4]],"spike",true,180);
         addGroup([[7,4]],"halfWall",true,180);
         addGroup([[9,4]],"spike",true,0);
         addGroup([[9,4]],"halfWall",true,0);
         addGroup([[17,4]],"spike",true,0);
         addGroup([[17,4]],"halfWall",true,0);
         addGroup([[15,8]],"spike",true,270);
         addGroup([[15,8]],"halfWall",true,270);
         addGroup([[16,8]],"spike",true,270);
         addGroup([[16,8]],"halfWall",true,270);
         addGroup([[1,2],[2,2],[1,3],[1,4],[1,5],[1,7],[1,6],[2,7],[3,7],[4,7],[6,7],[5,7],[7,7],[8,7],[10,7],[9,7],[10,6],[10,2],[10,4],[10,3],[10,5],[11,4],[9,2],[8,2],[7,2],[6,2],[5,2],[4,2],[6,6]],"piston",false);
         addGroup([[16,6]],"key",false);
         addGroup([[12,2]],"door",true);
         addGroup([[15,4]],"key",false);
         addGroup([[8,3]],"door",true,90);
         addGroup([[8,4]],"key",false);
         addGroup([[13,8]],"door",true,90);
         addGroup([[13,-1]],"exit",true,"L0");
         addGroup([[13,9]],"exit",true,"R1");
         setManPosition([[13,1],[14,7]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,9);
         addGroup(get2DArray([0,0],[0,12]));
         addGroup(get2DArray([0,14],[0,17]));
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([8,5],[8,17]));
         addGroup(get2DArray([1,0],[7,0]));
         addGroup(get2DArray([1,17],[7,17]));
         addGroup([[3,5],[2,15],[2,16],[3,15],[5,15],[6,15],[6,16],[5,13],[6,13],[6,12],[7,12]]);
         addGroup([[2,7],[2,9],[2,10],[1,9],[1,10],[2,8]],"piston",false);
         addGroup([[3,7],[3,8],[3,9],[3,10],[4,7]],"piston",false);
         addGroup([[1,5],[1,6],[2,6],[3,6],[2,5]],"piston",false);
         addGroup([[1,11],[1,12],[2,11],[4,11],[4,10],[4,8],[5,8],[7,8],[7,7],[3,11],[4,9],[6,8]],"piston",false);
         addGroup([[7,16]],"key",false);
         addGroup([[8,4]],"door",true);
         addGroup([[7,1]],"key",true);
         addGroup([[4,15]],"door",true,90);
         addGroup([[5,16]],"book",false,13);
         addGroup([[9,4]],"exit",true,"B0");
         addGroup([[-1,13]],"exit",true,"T1");
         setManPosition([[7,4],[1,13]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,3]));
         addGroup(get2DArray([0,5],[0,8]));
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([8,5],[8,8]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,8],[6,8]));
         addGroup([[5,2]],"spike",true,90);
         addGroup([[5,2]],"halfWall",true,90);
         addGroup([[5,3]],"spike",true,270);
         addGroup([[5,3]],"halfWall",true,270);
         addGroup([[7,8]],"spike",true,270);
         addGroup([[7,8]],"halfWall",true,270);
         addGroup([[2,1],[2,2],[5,1],[5,4],[3,4],[3,5],[7,5]]);
         addGroup(get2DArray([6,4],[6,6]));
         addGroup(get2DArray([1,6],[3,6]));
         addGroup([[7,6]],"key",false);
         addGroup([[1,2]],"door",true,90);
         addGroup([[1,1]],"key",false);
         addGroup([[3,7]],"door",true);
         addGroup([[1,7]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[8,4]],"specialDoor",true);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[-1,4]],"exit",true,"T1");
         addGroup([[9,4]],"exit",true,"B2");
         setManPosition([[4,1],[1,4],[7,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,8]));
         addGroup(get2DArray([8,0],[8,8]));
         addGroup(get2DArray([1,0],[7,0]));
         addGroup(get2DArray([1,8],[3,8]));
         addGroup(get2DArray([5,8],[7,8]));
         addGroup([[5,7],[3,1]]);
         addGroup([[2,2],[2,3],[2,4],[2,6],[4,6],[4,4],[4,2],[6,2],[6,4],[6,5],[6,6],[2,5],[3,6],[4,5],[4,3],[5,2],[6,3]],"piston",false);
         addGroup([[7,1]],"book",false,9);
         addGroup([[4,9]],"exit",true,"R0");
         setManPosition([[4,7]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup([[0,0],[0,2],[0,3],[0,5],[0,8],[8,8],[8,0]]);
         addGroup(get2DArray([8,3],[8,5]));
         addGroup(get2DArray([3,0],[5,0]));
         addGroup(get2DArray([3,8],[5,8]));
         addGroup([[4,4]]);
         addGroup([[0,1]],"spike",true,180);
         addGroup([[0,1]],"halfWall",true,180);
         addGroup([[0,6]],"spike",true,180);
         addGroup([[0,6]],"halfWall",true,180);
         addGroup([[0,7]],"spike",true,180);
         addGroup([[0,7]],"halfWall",true,180);
         addGroup([[1,8]],"spike",true,270);
         addGroup([[1,8]],"halfWall",true,270);
         addGroup([[2,8]],"spike",true,270);
         addGroup([[2,8]],"halfWall",true,270);
         addGroup([[6,8]],"spike",true,270);
         addGroup([[6,8]],"halfWall",true,270);
         addGroup([[7,8]],"spike",true,270);
         addGroup([[7,8]],"halfWall",true,270);
         addGroup([[8,1]],"spike",true,0);
         addGroup([[8,1]],"halfWall",true,0);
         addGroup([[8,2]],"spike",true,0);
         addGroup([[8,2]],"halfWall",true,0);
         addGroup([[8,6]],"spike",true,0);
         addGroup([[8,6]],"halfWall",true,0);
         addGroup([[8,7]],"spike",true,0);
         addGroup([[8,7]],"halfWall",true,0);
         addGroup([[1,0]],"spike",true,90);
         addGroup([[1,0]],"halfWall",true,90);
         addGroup([[2,0]],"spike",true,90);
         addGroup([[2,0]],"halfWall",true,90);
         addGroup([[6,0]],"spike",true,90);
         addGroup([[6,0]],"halfWall",true,90);
         addGroup([[7,0]],"spike",true,90);
         addGroup([[7,0]],"halfWall",true,90);
         addGroup([[1,3],[2,3],[3,3],[5,3],[5,4],[5,5],[5,7],[4,7],[3,7],[1,7],[1,6],[1,5],[2,7],[5,6],[4,3]],"piston",false);
         addGroup([[0,4]],"specialDoor");
         addGroup([[-1,4]],"exit",true,"T0");
         setManPosition([[1,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([8,0],[8,3]));
         addGroup(get2DArray([8,5],[8,8]));
         addGroup(get2DArray([0,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([0,1],[0,8]));
         addGroup(get2DArray([1,8],[6,8]));
         addGroup([[5,2]],"spike",true,90);
         addGroup([[5,2]],"halfWall",true,90);
         addGroup([[1,6]],"spike",true,270);
         addGroup([[1,6]],"halfWall",true,270);
         addGroup([[5,3]],"spike",true,270);
         addGroup([[5,3]],"halfWall",true,270);
         addGroup([[7,8]],"spike",true,270);
         addGroup([[7,8]],"halfWall",true,270);
         addGroup([[2,1],[2,2],[5,1],[5,4],[2,6],[7,5]]);
         addGroup(get2DArray([6,4],[6,6]));
         addGroup(get2DArray([3,4],[3,6]));
         addGroup([[7,6]],"key",false);
         addGroup([[1,2]],"door",true,90);
         addGroup([[1,1]],"key",false);
         addGroup([[3,7]],"door",true);
         addGroup([[1,7]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[8,4]],"specialDoor",true);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[9,4]],"exit",true,"B1");
         setManPosition([[4,1],[7,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,8]));
         addGroup(get2DArray([8,0],[8,8]));
         addGroup(get2DArray([2,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,8],[3,8]));
         addGroup(get2DArray([5,8],[7,8]));
         addGroup([[2,2],[2,4],[2,6],[6,1],[6,3],[6,5],[6,7]]);
         addGroup([[1,0]],"spike",true,90);
         addGroup([[1,0]],"halfWall",true,90);
         addGroup([[3,2],[4,2],[5,2]],"piston",false);
         addGroup([[3,3],[4,3],[5,3]],"piston",false);
         addGroup([[3,4],[4,4],[5,4]],"piston",false);
         addGroup([[3,5],[4,5],[5,5]],"piston",false);
         addGroup([[3,6],[4,6],[5,6]],"piston",false);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[4,9]],"exit",true,"R1");
         setManPosition([[4,1],[4,7]]);
         addGroup([[5,5]],"man",false);
         createRoom(18,18);
         addGroup(get2DArray([0,9],[0,17]));
         addGroup(get2DArray([9,0],[9,9]));
         addGroup(get2DArray([17,0],[17,3]));
         addGroup(get2DArray([17,5],[17,17]));
         addGroup(get2DArray([1,9],[3,9]));
         addGroup(get2DArray([5,9],[8,9]));
         addGroup(get2DArray([9,0],[16,0]));
         addGroup(get2DArray([1,17],[3,17]));
         addGroup(get2DArray([5,17],[16,17]));
         addGroup([[11,3],[11,4],[2,13],[4,14],[11,1],[15,2],[15,6],[13,15],[15,13],[15,15],[11,6],[11,11],[15,5],[16,5],[7,16],[7,10],[2,10],[3,16],[1,15]]);
         addGroup(get2DArray([3,12],[3,14]));
         addGroup(get2DArray([14,2],[14,5]));
         addGroup(get2DArray([5,10],[5,13]));
         addGroup([[7,11]],"spike",true,0);
         addGroup([[7,11]],"halfWall",true,0);
         addGroup([[7,15]],"spike",true,0);
         addGroup([[7,15]],"halfWall",true,0);
         addGroup([[15,8]],"spike",true,0);
         addGroup([[15,8]],"halfWall",true,0);
         addGroup([[15,9]],"spike",true,0);
         addGroup([[15,9]],"halfWall",true,0);
         addGroup([[15,10]],"spike",true,0);
         addGroup([[15,10]],"halfWall",true,0);
         addGroup([[15,11]],"spike",true,0);
         addGroup([[15,11]],"halfWall",true,0);
         addGroup([[15,12]],"spike",true,0);
         addGroup([[15,12]],"halfWall",true,0);
         addGroup([[15,14]],"spike",true,0);
         addGroup([[15,14]],"halfWall",true,0);
         addGroup([[5,14]],"spike",true,180);
         addGroup([[5,14]],"halfWall",true,180);
         addGroup([[11,7]],"spike",true,180);
         addGroup([[11,7]],"halfWall",true,180);
         addGroup([[11,8]],"spike",true,180);
         addGroup([[11,8]],"halfWall",true,180);
         addGroup([[11,9]],"spike",true,180);
         addGroup([[11,9]],"halfWall",true,180);
         addGroup([[11,10]],"spike",true,180);
         addGroup([[11,10]],"halfWall",true,180);
         addGroup([[8,11]],"spike",true,90);
         addGroup([[8,11]],"halfWall",true,90);
         addGroup([[9,11]],"spike",true,90);
         addGroup([[9,11]],"halfWall",true,90);
         addGroup([[10,11]],"spike",true,90);
         addGroup([[10,11]],"halfWall",true,90);
         addGroup([[12,4]],"spike",true,90);
         addGroup([[12,4]],"halfWall",true,90);
         addGroup([[13,4]],"spike",true,90);
         addGroup([[13,4]],"halfWall",true,90);
         addGroup([[8,15]],"spike",true,270);
         addGroup([[8,15]],"halfWall",true,270);
         addGroup([[9,15]],"spike",true,270);
         addGroup([[9,15]],"halfWall",true,270);
         addGroup([[10,15]],"spike",true,270);
         addGroup([[10,15]],"halfWall",true,270);
         addGroup([[11,15]],"spike",true,270);
         addGroup([[11,15]],"halfWall",true,270);
         addGroup([[12,15]],"spike",true,270);
         addGroup([[12,15]],"halfWall",true,270);
         addGroup([[14,15]],"spike",true,270);
         addGroup([[14,15]],"halfWall",true,270);
         addGroup([[13,6],[13,7],[13,5],[12,6],[14,6]],"piston",false);
         addGroup([[8,16]],"key",false);
         addGroup([[17,4]],"door",true);
         addGroup([[8,10]],"key",false);
         addGroup([[11,2]],"door",true);
         addGroup([[4,8]],"exit",true,"L0");
         addGroup([[4,18]],"exit",true,"R1");
         addGroup([[18,4]],"exit",true,"B2");
         setManPosition([[3,10],[4,16],[16,4]]);
         addGroup([[14,14]],"man",false);
         createRoom(9,18);
         addGroup([[17,0],[8,0],[13,0],[17,2],[17,3],[17,5],[17,6],[17,8],[0,5],[0,6],[0,8],[6,8]]);
         addGroup(get2DArray([0,1],[0,3]));
         addGroup(get2DArray([0,0],[3,0]));
         addGroup([[2,2],[3,3],[3,5],[5,5],[5,6],[6,3],[7,5],[7,6],[9,2],[9,3],[13,5],[13,6],[14,2],[14,3],[14,5],[14,6],[16,6],[7,2],[12,2],[12,3]]);
         addGroup([[14,4]],"spike",true,0);
         addGroup([[14,4]],"halfWall",true,0);
         addGroup([[17,1]],"spike",true,0);
         addGroup([[17,1]],"halfWall",true,0);
         addGroup([[17,7]],"spike",true,0);
         addGroup([[17,7]],"halfWall",true,0);
         addGroup([[0,7]],"spike",true,180);
         addGroup([[0,7]],"halfWall",true,180);
         addGroup([[3,4]],"spike",true,180);
         addGroup([[3,4]],"halfWall",true,180);
         addGroup([[4,0]],"spike",true,90);
         addGroup([[4,0]],"halfWall",true,90);
         addGroup([[5,0]],"spike",true,90);
         addGroup([[5,0]],"halfWall",true,90);
         addGroup([[6,0]],"spike",true,90);
         addGroup([[6,0]],"halfWall",true,90);
         addGroup([[7,0]],"spike",true,90);
         addGroup([[7,0]],"halfWall",true,90);
         addGroup([[9,0]],"spike",true,90);
         addGroup([[9,0]],"halfWall",true,90);
         addGroup([[10,0]],"spike",true,90);
         addGroup([[10,0]],"halfWall",true,90);
         addGroup([[11,0]],"spike",true,90);
         addGroup([[11,0]],"halfWall",true,90);
         addGroup([[12,0]],"spike",true,90);
         addGroup([[12,0]],"halfWall",true,90);
         addGroup([[14,0]],"spike",true,90);
         addGroup([[14,0]],"halfWall",true,90);
         addGroup([[15,0]],"spike",true,90);
         addGroup([[15,0]],"halfWall",true,90);
         addGroup([[16,0]],"spike",true,90);
         addGroup([[16,0]],"halfWall",true,90);
         addGroup([[4,3]],"spike",true,90);
         addGroup([[4,3]],"halfWall",true,90);
         addGroup([[5,3]],"spike",true,90);
         addGroup([[5,3]],"halfWall",true,90);
         addGroup([[10,3]],"spike",true,90);
         addGroup([[10,3]],"halfWall",true,90);
         addGroup([[11,3]],"spike",true,90);
         addGroup([[11,3]],"halfWall",true,90);
         addGroup([[1,6]],"spike",true,90);
         addGroup([[1,6]],"halfWall",true,90);
         addGroup([[2,6]],"spike",true,90);
         addGroup([[2,6]],"halfWall",true,90);
         addGroup([[3,6]],"spike",true,90);
         addGroup([[3,6]],"halfWall",true,90);
         addGroup([[4,6]],"spike",true,90);
         addGroup([[4,6]],"halfWall",true,90);
         addGroup([[8,6]],"spike",true,90);
         addGroup([[8,6]],"halfWall",true,90);
         addGroup([[9,6]],"spike",true,90);
         addGroup([[9,6]],"halfWall",true,90);
         addGroup([[10,6]],"spike",true,90);
         addGroup([[10,6]],"halfWall",true,90);
         addGroup([[11,6]],"spike",true,90);
         addGroup([[11,6]],"halfWall",true,90);
         addGroup([[12,6]],"spike",true,90);
         addGroup([[12,6]],"halfWall",true,90);
         addGroup([[3,2]],"spike",true,270);
         addGroup([[3,2]],"halfWall",true,270);
         addGroup([[4,2]],"spike",true,270);
         addGroup([[4,2]],"halfWall",true,270);
         addGroup([[5,2]],"spike",true,270);
         addGroup([[5,2]],"halfWall",true,270);
         addGroup([[6,2]],"spike",true,270);
         addGroup([[6,2]],"halfWall",true,270);
         addGroup([[10,2]],"spike",true,270);
         addGroup([[10,2]],"halfWall",true,270);
         addGroup([[11,2]],"spike",true,270);
         addGroup([[11,2]],"halfWall",true,270);
         addGroup([[15,2]],"spike",true,270);
         addGroup([[15,2]],"halfWall",true,270);
         addGroup([[16,2]],"spike",true,270);
         addGroup([[16,2]],"halfWall",true,270);
         addGroup([[4,5]],"spike",true,270);
         addGroup([[4,5]],"halfWall",true,270);
         addGroup([[8,5]],"spike",true,270);
         addGroup([[8,5]],"halfWall",true,270);
         addGroup([[9,5]],"spike",true,270);
         addGroup([[9,5]],"halfWall",true,270);
         addGroup([[10,5]],"spike",true,270);
         addGroup([[10,5]],"halfWall",true,270);
         addGroup([[11,5]],"spike",true,270);
         addGroup([[11,5]],"halfWall",true,270);
         addGroup([[12,5]],"spike",true,270);
         addGroup([[12,5]],"halfWall",true,270);
         addGroup([[1,8]],"spike",true,270);
         addGroup([[1,8]],"halfWall",true,270);
         addGroup([[2,8]],"spike",true,270);
         addGroup([[2,8]],"halfWall",true,270);
         addGroup([[3,8]],"spike",true,270);
         addGroup([[3,8]],"halfWall",true,270);
         addGroup([[4,8]],"spike",true,270);
         addGroup([[4,8]],"halfWall",true,270);
         addGroup([[5,8]],"spike",true,270);
         addGroup([[5,8]],"halfWall",true,270);
         addGroup([[7,8]],"spike",true,270);
         addGroup([[7,8]],"halfWall",true,270);
         addGroup([[8,8]],"spike",true,270);
         addGroup([[8,8]],"halfWall",true,270);
         addGroup([[9,8]],"spike",true,270);
         addGroup([[9,8]],"halfWall",true,270);
         addGroup([[10,8]],"spike",true,270);
         addGroup([[10,8]],"halfWall",true,270);
         addGroup([[11,8]],"spike",true,270);
         addGroup([[11,8]],"halfWall",true,270);
         addGroup([[12,8]],"spike",true,270);
         addGroup([[12,8]],"halfWall",true,270);
         addGroup([[13,8]],"spike",true,270);
         addGroup([[13,8]],"halfWall",true,270);
         addGroup([[14,8]],"spike",true,270);
         addGroup([[14,8]],"halfWall",true,270);
         addGroup([[15,8]],"spike",true,270);
         addGroup([[15,8]],"halfWall",true,270);
         addGroup([[16,8]],"spike",true,270);
         addGroup([[16,8]],"halfWall",true,270);
         addGroup([[-1,4]],"exit",true,"T0");
         addGroup([[18,4]],"exit",true,"B1");
         setManPosition([[1,4],[16,4]]);
         addGroup([[5,5]],"man",false);
         createRoom(9,9);
         addGroup(get2DArray([0,0],[0,3]));
         addGroup(get2DArray([0,5],[0,8]));
         addGroup(get2DArray([8,0],[8,8]));
         addGroup(get2DArray([1,0],[3,0]));
         addGroup(get2DArray([5,0],[7,0]));
         addGroup(get2DArray([1,8],[7,8]));
         addGroup([[3,3],[3,7],[6,6],[6,7]]);
         addGroup(get2DArray([1,2],[5,2]));
         addGroup(get2DArray([6,2],[6,4]));
         addGroup([[3,4],[3,5],[3,6],[4,4],[4,5],[4,6]],"piston",false);
         addGroup([[1,1]],"key",false);
         addGroup([[4,0]],"door",true,90);
         addGroup([[7,7]],"book",false,10);
         addGroup([[4,-1]],"exit",true,"L0");
         addGroup([[-1,4]],"exit",true,"T1");
         setManPosition([[4,1],[1,4]]);
         addGroup([[5,5]],"man",false);
      }
      
      public function getExit(param1:uint, param2:String) : Object
      {
         var _loc3_:Array = null;
         var _loc4_:String = null;
         var _loc5_:uint = 0;
         var _loc6_:* = undefined;
         _loc3_ = param2.split("");
         _loc4_ = String(_loc3_[0]);
         _loc5_ = Number(_loc3_[1]);
         for each(_loc6_ in mapEntrances)
         {
            if(_loc6_.id == param1 && _loc5_ == _loc6_.entranceId && _loc4_ == _loc6_.dir)
            {
               return _loc6_;
            }
         }
         return {};
      }
      
      public function createRoom(param1:Number, param2:Number, param3:Number = 25, param4:String = "level") : void
      {
         cRoom = new Array();
         cMan = new Array();
         levels.push({
            "data":cRoom,
            "xGrid":param1,
            "yGrid":param2,
            "gridWidth":param3,
            "type":param4,
            "manPositions":cMan
         });
      }
      
      public function getRoomData() : Object
      {
         return levels[currentLevel];
      }
      
      public function getData(param1:uint) : Object
      {
         return levels[param1];
      }
      
      public function editActiveRoom(param1:Array) : void
      {
         var _loc2_:int = 0;
         _loc2_ = 0;
         while(_loc2_ < mapEntrances.length)
         {
            if(mapEntrances[_loc2_].id == 25)
            {
               mapEntrances.splice(_loc2_,1);
               addEntrance(param1,["T"],25,0);
               break;
            }
            _loc2_++;
         }
         levels[0].data[25].points = [param1];
      }
      
      public function getRoomLocation(param1:uint) : Object
      {
         var _loc2_:Array = null;
         var _loc3_:uint = 0;
         var _loc4_:uint = 0;
         var _loc5_:uint = 0;
         var _loc6_:uint = 0;
         var _loc7_:* = undefined;
         _loc2_ = levels[0].data[param1].points;
         _loc3_ = uint(_loc2_[0][1]);
         _loc4_ = uint(_loc2_[0][1]);
         _loc5_ = uint(_loc2_[0][0]);
         _loc6_ = uint(_loc2_[0][0]);
         for each(_loc7_ in _loc2_)
         {
            _loc3_ = _loc3_ < _loc7_[1] ? _loc3_ : uint(_loc7_[1]);
            _loc5_ = _loc5_ < _loc7_[0] ? _loc5_ : uint(_loc7_[0]);
            _loc4_ = _loc4_ > _loc7_[1] ? _loc4_ : uint(_loc7_[1]);
            _loc6_ = _loc6_ > _loc7_[0] ? _loc6_ : uint(_loc7_[0]);
         }
         return {
            "x":(_loc3_ + _loc4_) / 2,
            "y":(_loc5_ + _loc6_) / 2
         };
      }
      
      private function getAllData() : void
      {
         allData = Cookie.getInstance().getAllData();
      }
      
      private function createHiddenRoom() : void
      {
         var _loc1_:Object = null;
         var _loc2_:Object = null;
         var _loc3_:Object = null;
         var _loc4_:Object = null;
         var _loc5_:Object = null;
         var _loc6_:Object = null;
         var _loc7_:Object = null;
         var _loc8_:Object = null;
         var _loc9_:Object = null;
         _loc1_ = new Object();
         _loc2_ = new Object();
         _loc3_ = new Object();
         _loc4_ = new Object();
         _loc5_ = new Object();
         _loc6_ = new Object();
         _loc7_ = new Object();
         _loc8_ = new Object();
         _loc9_ = new Object();
         hiddenRoomSets = [_loc1_,_loc2_,_loc3_,_loc4_,_loc5_,_loc6_,_loc7_,_loc8_,_loc9_];
         _loc1_.point = [2,4];
         _loc1_.position = [-23.4,-40];
         _loc1_.nPoint = [_loc1_,_loc1_,_loc1_,_loc2_];
         _loc2_.point = [2,3];
         _loc2_.position = [-39.6,-40];
         _loc2_.nPoint = [_loc3_,_loc1_,_loc2_,_loc2_];
         _loc3_.point = [3,3];
         _loc3_.position = [-39.6,-24];
         _loc3_.nPoint = [_loc3_,_loc3_,_loc2_,_loc4_];
         _loc4_.point = [3,2];
         _loc4_.position = [-55.4,-24];
         _loc4_.nPoint = [_loc6_,_loc3_,_loc4_,_loc4_];
         _loc5_.point = [5,2];
         _loc5_.position = [-55.4,8];
         _loc5_.nPoint = [_loc6_,_loc9_,_loc4_,_loc5_];
         _loc6_.point = [6,2];
         _loc6_.position = [-55.4,23.7];
         _loc6_.nPoint = [_loc6_,_loc8_,_loc4_,_loc6_];
         _loc7_.point = [5,3];
         _loc7_.position = [-39.6,8];
         _loc7_.nPoint = [_loc8_,_loc9_,_loc7_,_loc5_];
         _loc8_.point = [6,3];
         _loc8_.position = [-39.6,23.7];
         _loc8_.nPoint = [_loc8_,_loc8_,_loc7_,_loc6_];
         _loc9_.point = [5,4];
         _loc9_.position = [-23.4,8];
         _loc9_.nPoint = [_loc9_,_loc9_,_loc9_,_loc5_];
      }
      
      public function clearState(param1:Boolean = true, param2:Boolean = false) : void
      {
         if(param1)
         {
            currentRoom = null;
         }
         else
         {
            currentRoom.player.doAction("stand");
            currentRoom.player.stopMoving();
         }
         if(!param2)
         {
            isSleep = false;
         }
      }
      
      public function setMessage() : void
      {
         messages = new Array();
         messages.push(["Hmm, I can move by pressing left and right. And I can jump by pressing up. Z and X seem to rotate the entire world. But how do I know all this?","我可以按左和右跑动，按上进行跳跃，而且可以用Z和X来旋转整个场地。但我如何从这里脱出呢？","Hmm, ik kan bewegen door op links en rechts te drukken. En ik kan springen door op naar boven te drukken. Z en X draaien de hele wereld rond. Maar waarom weet ik dit allemaal?","Hmm, je peux me déplacer en appuyant à gauche et à droite. Je peux sauter en appuyant sur la flèche du haut. Z et X semblent faire tourner le monde entier. Mais comment est-ce que je sais tout ça ?","Hmm, ich kann mich bewegen, indem ich die Pfeiltasten nach links und rechts drücke und springen, indem ich die Pfeiltaste nach oben drücke. Mit Z und X kann ich diese ganze Welt hier drehen. Aber warum weiß ich das alles bloß?","Hmm, poruszam się dzięki strzałkom w lewo i w prawo. A skaczę, naciskając strzałkę w górę. Z i X wydaje się obracać cały świat. Ale skąd ja to wszystko wiem?","Hm, jag kan förflytta mig genom att trycka vänster och höger. Och jag kan hoppa genom att trycka upp. Z och X verkar rotera hela världen. Hur vet jag detta?","Mmm, posso muovermi premendo i tasti freccia Su, Destra e Sinistra. I tasti Z e X sembra servano a far ruotare l\'intero mondo. Ma come mai mi è dato sapere tutto questo?","Hum, me puedo mover pulsando izquierda y derecha. También puedo saltar pulsando arriba. Las teclas Z y X hacen que el mundo entero dé vueltas. ¿Pero cómo sé yo todo esto?","Hmm, para andar, uso as setas direita e esquerda. Para pular, a seta para cima. Parece que Z e X fazem o mundo girar. Mas como é que sei de tudo isso?","Hmm, Saya bisa bergerak dengan menekan tombol panah kiri dan kanan. Dan saya bisa melompat dengan menekan tombol panah atas. Tombol Z dan X kelihatannya untuk memutar seluruh dunia. Tapi mengapa saya mengetahui semua ini?","Хм, я могу двигаться, нажимая клавиши \"влево\" и \"вправо\". А если нажать клавишу \"вверх\", я могу прыгать. Клавиши Z и X, похоже, заставляют весь мир поворачиваться. Но откуда я все это знаю?","Hmm, I can move by pressing left and right and can jump by pressing up. Z and X seem to rotate the entire world; but how do I know all this?","Hmm, I can move by pressing left and right and can jump by pressing up. Z and X seem to rotate the entire world; but how do I know all this?","Hmm, sola ve sağa basarak hareket edebilirim. Yukarı basarak da zıplayabilirim. Sanırım Z ve X bütün dünyayı döndürüyor. Fakat bütün bunları neden biliyorum?","Hmm, saya boleh bergerak dengan menekan ke kiri dan kanan. Z dan X boleh memutar seluruh dunia. Tetapi mengapa saya mengetahui semua ini?","Humm, eu posso mover-me pressionando a seta da esquerda e a da direita. E posso saltar pressionando a seta de cima. Z e X servem para fazer girar o mundo. Mas como sei eu tudo isto? "]);
         messages.push(["By running and jumping at ledges, I can climb onto them. This will help me avoid those nasty spikes. But will it help me find the exit from this place?","用跑和跳我能爬上高墙，而且可以帮助我避开可恶的钉板，但这些能帮我找到出口吗？","Door te rennen en te springen kan ik op dingen klimmen. Dan kan ik tenminste die nare stekels ontwijken. Maar zal het mij ook uit dit doolhof helpen?","En courant et sautant sur les rebords, on peut y monter. Je pourrai ainsi éviter ces pointes acérées. Mais est-ce que cela va m\'aider à sortir de cet endroit ?","Wenn ich laufe und auf Vorsprünge springe, kann ich nach oben klettern. So kann ich diesen schlimmen Stacheln ausweichen. Aber wird mir das auch helfen, von hier zu entkommen?","Podbiegając i wskakując na krawędzie mogę się na nie wspiąć. To pomoże ominąć mi te okropne włócznie. Ale czy umożliwi mi znalezienie wyjścia z tego miejsca?","Genom att springa och hoppa kan jag klättra upp på saker. På så sätt kan jag undvika spetsarna. Men hjälper det mig att hitta utgången?","Se prendo la rincorsa e salto sulle sporgenze riuscirò ad arrampicarmi. In questo modo potrò evitare quei maledetti spuntoni. Ma servirà a farmi trovare una via d\'uscita da questo posto?","Corriendo y saltando por las cornisas, puedo escalar. Así conseguiré esquivar esas asquerosas serpientes. Pero con eso, ¿seré capaz de salir de este lugar?","Correndo e pulando nas saliências, consigo subir nelas. Isso me ajudará a evitar os pregos perigosos. Mas será que me ajuda a encontrar a saída?","Dengan berlari dan melompati birai, Saya bisa memanjat ke atas benda-benda. Ini akan membantu saya untuk menghindari paku besar yang kotor. Tapi akankah saya terbantu untuk menemukan jalan keluar dari tempat ini?","Запрыгивая с разбегу на выступы, я могу взбираться на возвышения. Это поможет мне избежать этих жутких шипов. Но поможет ли мне это найти выход отсюда?","I can climb onto ledges by running and jumping at them. This will help me avoid those nasty spikes. But will it help me find the way out of this place?","I can climb onto ledges by running and jumping at them. This will help me avoid those nasty spikes. But will it help me find the way out of this place?","Koşarak ve çıkıntıların üzerinden zıplayarak tırmanabilirim. Bu sayede çivilerden uzak durabilirim. Ama bütün bunlar buradan çıkmama yardımcı olacak mı?","Dengan berlari dan melompat pada belebas, saya boleh memanjat pada benda. Ini membantu saya mengelak daripada pepaku berbahaya. Tetapi adakah ia akan membantu saya keluar daripada tempat ini?","Correndo e saltando sobre as elevações, eu consigo subi-las. Isto ajudar-me-à a evitar os obstáculos. Mas será suficiente para me ajudar a sair deste sítio?"]);
         messages.push(["Do not enter the room beyond! I was almost immediately trapped! I have attached a key to the wall which might help you escape.","别到前面房间去了！我差点在那里丧命！但我在那里墙上挂着把钥匙可能对你的逃脱有帮助。","Ga niet naar de volgende kamer! Ik was bijna meteen opgesloten! Ik heb een sleutel aan de muur gehangen om je verder te helpen.","N\'entrez surtout pas dans la pièce suivante ! J\'ai presque immédiatement été enfermé ! J\'ai attaché au mur une clé qui pourrait vous aider à vous échapper.","Geh nicht in diesen Raum! Ich saß sofort in der Falle! Ich habe einen Schlüssel an die Wand gehängt, der dir bei deiner Flucht helfen wird.","Nie wchodź do następnego pokoju! Ja prawie natychmiast zostałem uwięziony! Przyczepiłem klucz do ściany, być może to pomoże ci uciec.","Gå inte in i rummet bortom! Jag blev omedelbart fången! Jag har hängt en nyckel på väggen. Den kanske kan hjälpa dig att fly.","Non entrate nella stanza accanto! Per poco non rimanevo in trappola! Ho appeso una chiave al muro che potrebbe servire in caso di fuga.","No entres a la siguiente habitación. ¡Casi quedo atrapado al instante! He colocado una llave en la pared que te ayudará a escapar.","Não entre na próxima sala! Fiquei preso quase imediatamente! Prendi uma chave à parede para ajudá-lo a escapar.","Jangan memasuki bagian luar ruangan! Saya hampir terjebak! Saya telah meletakkan sebuah kunci di dinding yang akan membantu saya melarikan diri.","Не заходите в следующую комнату! Я практически сразу же оказался в ловушке! Я прикрепил к стене ключ - возможно, он поможет вам выбраться из ловушки…","Do not enter the room beyond! I was nearly trapped then! I have placed a key on the wall which might help you escape.","Do not enter the room beyond! I was nearly trapped then! I have placed a key on the wall which might help you escape.","Bu odaya sakın girmeyin! Ben neredeyse tuzağa düşüyordum! Duvara bir anahtar astım, o kaçmanıza yardımcı olabilir.","Jangan masuk ke bilik di sebelah sana! Saya hampir terperangkap! Saya telah meletakkan kunci pada dinding yang mungkin membantu anda melepaskan diri.","Não entre no quarto que se segue. Fui quase logo apanhado! Deixei uma chave na parede que talvez lhe possa ser útil para escapar."]);
         messages.push(["By running and then jumping, I can reach farther. And if I\'m careful, I can stand pretty close to spikes as well. ","先跑起来然后跳能够跳得更远。并且如果足够小心的话我能紧贴着钉板站立而不受伤。","Door te rennen en te springen kan ik verder springen. En als ik voorzichtig ben kan ik heel dicht bij die stekels komen.","Si je prends de l\'élan avant de sauter, je peux aller plus loin. Et, si je fais attention, je peux même être assez proche des pointes.","Wenn ich laufe und springe, komme ich viel weiter. Und wenn ich vorsichtig bin, kann ich mich auch relativ nah an die Stachel stellen.","Biorąc rozbieg i wykonując skok mogę dotrzeć dalej. A jeśli będę ostrożny, mogę także stanąć całkiem blisko włóczni.","Genom att springa och hoppa kan jag nå längre. Och om jag är försiktig kan jag stå ganska nära spetsarna.","Se prendo la rincorsa e salto posso spingermi più lontano. Se sto attento, inoltre, posso anche sostare in prossimità degli spuntoni.","Corriendo y luego saltando puedo ir más lejos. Y sé que debo tener cuidado porque puedo estar muy cerca de las serpientes.","Correndo e pulando, posso chegar mais longe. E, se tomar cuidado, também posso me aproximar bastante dos pregos.","Dengan berlari dan kemudian melompat, Saya bisa mencapai lebih jauh. Dan jika saya berhati-hati, maka saya juga akan bisa berdiri dekat dengan paku.","Если разбежаться и прыгнуть, можно запрыгнуть подальше. Кроме того, если соблюдать осторожность, можно подходить довольно близко к шипам.","I can get further by running and then jumping. If I\'m careful I can stand pretty close to the spikes too.","I can get further by running and then jumping. If I\'m careful I can stand pretty close to the spikes too.","Koşup zıplayarak daha uzağa erişebilirim. Ayrıca dikkatli olursam çivilere oldukça yakın durabilirim.","Dengan berlari dan kemudian melompat, saya boleh pergi lebih jauh. Dan jika saya berhati-hati, saya juga boleh berdiri agak dekat dengan pepaku.","Correndo e depois saltando, posso chegar mais longe. E, se tiver cuidado, posso aproximar-me bastante dos obstáculos."]);
         messages.push(["I hate this world! Rooms, traps, doors, keys… What lunatic designed this? If I ever escape, he\'ll be sorry!","我憎恨这个地方！房间啊、机关啊、门啊、钥匙啊……哪个疯子设计了这一切？我逃出去后一定会宰了他！","Ik haat dit doolhof! Kamers, vallen, deuren… welke idioot heeft dit ontworpen? Als ik hier ooit uit kom dan zwaait er wat!","Je déteste ce monde ! Chambres, pièges, portes, clés… Quel est l\'abruti qui l\'a imaginé ? Si jamais je m\'en sors, il me le paiera !","Ich hasse diese Welt! Räume, Fallen, Türen, Schlüssel… Welcher Verrückte hat sich das bloß ausgedacht? Wenn ich jemals von hier entkomme, wird er das bereuen!","Nienawidzę tego świata! Pokoje, pułapki, drzwi, klucze... Jaki szaleniec to zaprojektował? Jeśli kiedykolwiek uda mi się uciec, pożałuje!","Jag hatar den här världen! Rum, fällor, dörrar, nycklar ... Vilken dåre har skapat det här? Han ska allt få!","Odio questo mondo! Stanze, trappole, porte, chiavi… Quale mente malata ha partorito tutto ciò? Se mai riuscirò a scappare, farà i conti con me!","¡Odio este mundo! Habitaciones, trampas, puertas, llaves… ¿A qué lunático se le ha podido ocurrir esto? Si me escapo, haré que se arrepienta por todo lo que ha hecho.","Detesto este mundo! Salas, alçapões, portas, chaves… Que lunático criou isto? Se eu não escapar, ele vai se arrepender!","Saya membenci dunia ini! Ruangan, jebakan, pintu, kunci… Orang gila mana yang mendesain ini? Jika saya pernah melarikan diri, maka dia akan merasa bersalah!","Ненавижу этот мир! Комнаты, ловушки, двери, ключи… Что за безумец создал все это? Если мне удастся выбраться отсюда, он пожалеет об этом!","I hate this world! Rooms, traps, doors, keys… What lunatic designed this? He\'ll be sorry if I ever escape from here!","I hate this world! Rooms, traps, doors, keys… What lunatic designed this? He\'ll be sorry if I ever escape from here!","Bu dünyadan nefret ediyorum! Odalar, tuzaklar, kapılar, anahtarlar... Hangi kaçık tasarlamış bunu? Buradan çıkmayı başarabilirsem buna pişman olacak!","Saya benci dunia ini! Bilik, perangkap, pintu, kunci...Orang gila mana yang merekanya?Jika saya dapat melepaskan diri, dia akan menyesal!","Eu odeio este mundo! Salas, armadilhas, portas, chaves... Quem foi o lunático que criou isto? Se conseguir escapar, está tramado!"]);
         messages.push(["I’m tired. I can\'t go on. How much further is it to the real end?","真正的出口到底还有多远？我太累了，我想我再也出不去了。","Ik ben zo moe. Ik kan echt niet meer verder. Hoe ver is het nog voordat ik bij het echte einde kom?","Je n\'en peux plus. Je n\'arrive plus à avancer. Jusqu\'où faudra-t-il aller pour trouver la vraie sortie ?","Ich bin müde. Ich kann nicht mehr. Wie weit ist es denn noch bis zum Ausgang?","Jestem zmęczony. Nie mogę iść dalej. Jak daleko jeszcze do końca?","Jag är trött. Jag orkar inte fortsätta. Hur långt är det kvar till slutet?","Sono stanco. Non ce la faccio più. Quanto dista ancora la vera fine?","Estoy cansado. No puedo seguir. ¿Cuánto queda para el verdadero final?","Estou cansado. Não consigo prosseguir. Será que a saída ainda está muito longe?","Saya lelah. Saya tidak bisa lanjut lagi. Berapa jauh lagi untuk menuju ke akhir yang nyata?","Я устал и не в силах продолжать путь. Сколько же еще осталось блуждать до настоящего конца лабиринта?","I’m tired. I can\'t go on. How much further is it to the real end?","I’m tired. I can\'t go on. How much further is it to the real end?","Çok yoruldum. Devam edemeyeceğim. Gerçek çıkışa ulaşmama daha ne kadar kaldı?","Saya letih. Saya tidak dapat meneruskannya. Berapa jauh lagi ke penghujung sebenar?","Estou cansado. Não consigo avançar mais. Será que ainda falta muito até à verdadeira saída?"]);
         messages.push(["I can\'t go on anymore. If you find this, please take my red mantle. It\'s the most precious thing I own!","我放弃了。如果有人来到这里，请把我最心爱的红披风带走吧……","Ik kan niet meer verder. Aan wie dit vindt: neem mijn mantel. Het is zeer waardevol!","Je suis à bout de forces. Si vous trouvez cela, prenez donc mon manteau rouge. C\'est ce que je possède de plus précieux !","Ich kann nicht mehr weiter. Wer das hier findet, soll bitte meinen roten Mantel an sich nehmen. Er ist das Kostbarste, was ich habe!","Już nie mogę iść dalej. Jeśli to znajdziesz, zabierz proszę mój czerwony płaszcz. To najceniejsza rzecz, jaką posiadam!","Jag orkar inte längre. Om du läser det här - ta min röda mantel. Det är min käraste ägodel!","Non ce la faccio ad andare avanti. Se trovate questo, prendete il mio mantello rosso. È la cosa più preziosa che ho!","No puedo continuar. Si encuentras esto, coge mi manto rojo. ¡Es lo más preciado que tengo!","Não consigo continuar. Se encontrar este bilhete, fique com a minha capa vermelha. É o que tenho de mais precioso!","Saya tidak bisa lanjut lagi. Jika anda menemukan ini, tolong ambil mantel merah saya. Itu merupakan benda paling berharga yang saya miliki!","Я не в силах идти дальше. Если вы нашли эту записку, можете взять мой красный плащ - это самое ценное из того, что у меня есть!","I can\'t go on any more. If you find this, please take my red mantle. It is the most precious thing I own!","I can\'t go on any more. If you find this, please take my red mantle. It is the most precious thing I own!","Artık devam edemeyeceğim. Bu notu bulursanız, kırmızı pelerinimi alın. O benim en değerli varlığım!","Saya tidak dapat meneruskannya lagi. Jika anda menjumpai nota ini, sila ambil mantel merah saya. Ia merupakan harta paling bernilai saya miliki!","Não consigo avançar mais. Se ler isto, leve a minha manta vermelha. É a coisa mais preciosa que tenho!"]);
         messages.push(["I\'m starting to see things from the corner of my eyes.Shadows, cakes, exits… they\'re all just a lie!","出口、阳光、蛋糕，为什么我眼前出现了这些东西……这他妈的都是幻觉！","Ik begin dingen te zien die er niet zijn. Schaduwen, taarten, uitgangen… allemaal leugens!","Je commence à voir des choses qui n\'existent pas. Des ombres, des gâteaux, des issues... rien que des mensonges !","Ich beginne schon, Dinge aus dem Augenwinkel zu sehen. Schatten, Kuchen, Ausgänge… aber nichts davon ist real!","Zaczynam widzieć różne rzeczy kątem oka. Cienie, ciastka, wyjścia...  to wszystko tylko przywidzenia! ","Jag börjar se saker i ögonvrån. Skuggor, tårtor, utgångar ... det är bara en illusion!","Comincio a vedere strane cose con la coda dell\'occhio. Ombre, cibo, uscite... Ma è tutto una menzogna!","Estoy empezando a ver cosas por el rabillo del ojo. Sombras, tartas, salidas… ¡Es todo mentira!","Estou começando a ver coisas de soslaio. Sombras, bolos, saídas… é tudo mentira!","Saya mulai melihat benda-benda dari sudut mata saya. Bayangan, kue, jalan keluar… mereka semua hanyalah suatu kebohongan!","Краем глаза я начинаю замечать странные вещи… Тени, пироги, выходы… все это просто миражи!","I\'m starting to see things out of the corner of my eye. Shadows, cakes, exits… they\'re all just a lie!","I\'m starting to see things out of the corner of my eye. Shadows, cakes, exits… they\'re all just a lie!","Bir şeyler görmeye başladım. Gölgeler, kekler, çıkışlar… hepsi bir hayal gibi!","Saya mula melihat benda dari sudut mata saya. Bayang-bayang, kek, jalan keluar... semuanya bohong belaka!","Estou a começar a ver coisas pelo canto dos olhos. Sombras, bolos, saídas... É tudo mentira!"]);
         messages.push(["I can hear a strange sound coming from the next room. It\'s like a huge thing is blocking the door. Perhaps, if I rotate enough and move the thing out of the way, the door will open.","我听见隔壁房间传来的奇怪响声，像是有什么巨大的东西。是不是我旋转到合适的位置那里的秘门就会开启呢？","Ik kan een geluid horen in de volgende kamer. Het klinkt alsof een groot iets de deur blokkeert. Misschien als ik deze kamer goed draai kan ik het ding in de andere kamer uit de weg krijgen.","J\'entends un drôle de bruit de la pièce d\'à côté. On dirait  un énorme obstacle qui bloque la porte. Si je tourne assez et si j\'enlève l\'obstacle de la porte, j\'arriverai peut-être à sortir.","Ich höre ein seltsames Geräusch aus dem nächsten Raum kommen. Mir scheint, als blockiere ein großes Ding die Tür. Vielleicht bewegt es sich ja, wenn ich diese Welt genug drehe. Vielleicht öffnet sich die Tür dann ja.","Słyszę dziwny dźwięk dochodzący z sąsiedniego pokoju. Zupełnie jakby coś wielkiego blokowało drzwi. Może jeśli dostatecznie obrócę pokój i usunę tę rzecz z drogi, drzwi się otworzą.","Jag hör underliga ljud från nästa rum. Något stort verkar blockera dörren. Om jag roterar rummet kanske saken flyttar sig och dörren öppnas.","Sento uno strano suono provenire dalla stanza accanto. Qualcosa di gigantesco blocca la porta. Forse se ruotassi a sufficienza riuscirei a spostare questa cosa consentendo l\'apertura della porta.","Oigo un extraño sonido proveniente de la habitación de al lado. Es como si una cosa enorme estuviese bloqueando la puerta. Quizás, si rotase lo suficiente y me quitase de delante, la puerta se abriría.","Estou ouvindo um ruído estranho na sala ao lado. Parece que algo grande está bloqueando a porta. Talvez, se eu girar o bastante e tirar essa coisa do caminho, a porta se abra.","Saya bisa mendengar suara aneh yang datang dari ruangan sebelah. Itu semacam benda besar yang menutupi pintu tersebut. Kemungkinan jika saya memutar dan memindahkan benda keluar, maka pintu akan terbuka.","Из соседней комнаты  доносится странный звук. Похоже, дверь завалена каким-то громоздким предметом. Возможно, если повернуть комнату и сдвинуть предмет в сторону, дверь откроется... ","I can hear a strange sound coming from the next room. It\'s like a huge thing is blocking the door. Perhaps if I rotate enough and move the thing out of the way, the door will open.","I can hear a strange sound coming from the next room. It\'s like a huge thing is blocking the door. Perhaps if I rotate enough and move the thing out of the way, the door will open.","Diğer odadan tuhaf sesler geliyor. Sanki kapının arkasında devasa bir şey var. Yeterince döndürürsem o şeyi oradan kaldırıp kapıyı açabilirim.","Saya boleh mendengar bunyi pelik yang datang dari bilik sebelah. Ia seperti benda yang besar sedang menghalang pintu. Jika saya putar dan memindahkan benda tersebut daripada laluan, pintu akan terbuka.","Estou a ouvir um barulho estranho vindo da sala ao lado. É como se um grande obstáculo estivesse a bloquear a porta. Talvez se o conseguir mover o suficiente a porta abrirá."]);
         messages.push(["This path must lead to the real exit! Finally, I feared this insane maze would never end!","这条路很可能就是真正的出口！但我害怕这个世界就是永无止境的……","Ik ben bijna bij de echte uitgang! Eindelijk, ik was al bang dat dit dolle doolhof nooit zou eindigen!","Ce chemin doit mener vers la vraie sortie ! Ça y est, j\'ai bien cru que ce labyrinthe infernal n\'en finirait jamais !","Dieser Weg muss zum Ausgang führen\" Endlich! Ich dachte schon, ich finde nie einen Weg aus diesem verrückten Labyrinth heraus!","Ta ścieżka musi prowadzić do prawdziwego wyjścia! Nareszcie... Bałem się, że ten szalony labirynt nigdy się nie skończy!","Den här vägen måste leda till den riktiga utgången. Jag var rädd att det aldrig skulle ta slut!","Questo sentiero deve condurre alla vera uscita! Finalmente. Temevo che questo folle labirinto non avrebbe avuto mai fine!","¡Este camino seguro que lleva a la salida real!¡Por fin! Creía que este laberinto de locos nunca terminaría.","Este caminho deve levar à saída verdadeira! Finalmente! Pensei que este labirinto louco não teria fim!","Jalur ini seharusnya menuju ke jalan keluar yang sesungguhnya! Akhirnya, Saya ketakutan kalau jalan liku-liku ini tidak akan pernah berakhir!","Этот путь, должно быть, ведет к настоящему выходу! Наконец-то! Я уж боялся, что этот безумный лабиринт никогда не закончится!","This path must lead to the real exit! At last! I was afraid this insane maze would never end!","This path must lead to the real exit! At last! I was afraid this insane maze would never end!","Bu yol gerçek çıkışa gidiyor olmalı! Sonunda, bu çılgın labirentin hiç bitmeyeceğinden korkuyordum!","Laluan ini mesti menuju ke jalan keluar sebenar! Akhirnya, saya berasa takut jika pagar sesat gila ini tidak akan tamat!","Este caminho deve conduzir até à verdadeira saída! Finalmente. Já pensava que este estranho labirinto não tinha fim!"]);
         messages.push(["SECRET\n  Page 4\n\nDRAGON","SECRET\n  Page 4\n\nDRAGON","GEHEIM\n  Pagina 4\n\nDRAGON","SECRET\n  Page 4\n\nDRAGON","GEHEIM\n  Seite 4\n\nDRAGON","TAJNE\n  Strona 4\n\nDRAGON","HEMLIGT\n  Sidan 4\n\nDRAGON","RISERVATO\n  Pagina 4\n\nDRAGON","SECRETO\n  Página 4\n\nDRAGON","SEGREDO\n  Página 4\n\nDRAGON","RAHASIA\n  Halaman 4\n\nDRAGON","СЕКРЕТ\n  Страница 4\n\nDRAGON","SECRET\n  Page 4\n\nDRAGON","SECRET\n  Page 4\n\nDRAGON","ÇOK GİZLİ\n  Sayfa 4\n\nDRAGON","RAHSIA\n  Halaman 4\n\nDRAGON","SEGREDO\n  Página 4\n\nDRAGON"]);
         messages.push(["SECRET\n  Page 3\n\n2008","SECRET\n  Page 3\n\n2008","GEHEIM\n  Pagina 3\n\n2008","SECRET\n  Page 3\n\n2008","GEHEIM\n  Seite 3\n\n2008","TAJNE\n  Strona 3\n\n2008","HEMLIGT\n  Sidan 3\n\n2008","RISERVATO\n  Pagina 3\n\n2008","SECRETO\n  Página 3\n\n2008","SEGREDO\n  Página 3\n\n2008","RAHASIA\n  Halaman 3\n\n2008","СЕКРЕТ\n  Страница 3\n\n2008","SECRET\n  Page 3\n\n2008","SECRET\n  Page 3\n\n2008","ÇOK GİZLİ\n  Sayfa 3\n\n2008","RAHSIA\n  Halaman 3\n\n2008","SEGREDO\n  Página 3\n\n2008"]);
         messages.push(["SECRET\n  Page 2\n\nPROJECT J","SECRET\n  Page 2\n\nPROJECT J","GEHEIM\n  Pagina 2\n\nPROJECT J","SECRET\n  Page 2\n\nPROJECT J","GEHEIM\n  Seite 2\n\nPROJECT J","TAJNE\n  Strona 2\n\nPROJECT J","HEMLIGT\n  Sidan 2\n\nPROJECT J","RISERVATO\n  Pagina 2\n\nPROJECT J","SECRETO\n  Página 2\n\nPROJECT J","SEGREDO\n  Página 2\n\nPROJECT J","RAHASIA\n  Halaman 2\n\nPROJECT J","СЕКРЕТ\n  Страница 2\n\nPROJECT J","SECRET\n  Page 2\n\nPROJECT J","SECRET\n  Page 2\n\nPROJECT J","ÇOK GİZLİ\n  Sayfa 2\n\nPROJECT J","RAHSIA\n  Halaman 2\n\nPROJECT J","SEGREDO\n  Página 2\n\nPROJECT J"]);
         messages.push(["SECRET\n  Page 1\n\n1994","SECRET\n  Page 1\n\n1994","GEHEIM\n  Pagina 1\n\n1994","SECRET\n  Page 1\n\n1994","GEHEIM\n  Seite 1\n\n1994","TAJNE\n  Strona 1\n\n1994","HEMLIGT\n  Sidan 1\n\n1994","RISERVATO\n  Pagina 1\n\n1994","SECRETO\n  Página 1\n\n1994","SEGREDO\n  Página 1\n\n1994","RAHASIA\n  Halaman 1\n\n1994","СЕКРЕТ\n  Страница 1\n\n1994","SECRET\n  Page 1\n\n1994","SECRET\n  Page 1\n\n1994","ÇOK GİZLİ\n  Sayfa 1\n\n1994","RAHSIA\n  Halaman 1\n\n1994","SEGREDO\n  Página 1\n\n1994"]);
      }
      
      public function createMainMap() : void
      {
         roomLevel = [1,2,1,3,4,2,1,2,4,1,3,1,3,1,4,4,1,4,1,2,2,2,1,1,1,1,1,3,2,1,60];
         createRoom(11,11,50,"map");
         addGroup([[1,1]],"man",false);
         addGroup([[5,5]],"virtual");
         addGroup([[4,6],[4,7]],"virtual");
         addGroup([[3,7]],"virtual");
         addGroup([[2,5],[2,6],[3,6]],"virtual");
         addGroup([[1,8],[1,9],[2,8],[2,9]],"virtual");
         addGroup([[1,6],[1,7]],"virtual");
         addGroup([[3,9]],"virtual");
         addGroup([[4,8],[4,9]],"virtual");
         addGroup([[5,7],[5,8],[6,7],[6,8]],"virtual");
         addGroup([[6,6]],"virtual");
         addGroup([[7,6],[8,5],[8,6]],"virtual");
         addGroup([[8,7]],"virtual");
         addGroup([[7,8],[6,9],[7,9]],"virtual");
         addGroup([[9,6]],"virtual");
         addGroup([[8,8],[8,9],[9,8],[9,9]],"virtual");
         addGroup([[6,4],[6,5],[7,4],[7,5]],"virtual");
         addGroup([[7,3]],"virtual");
         addGroup([[7,1],[7,2],[8,1],[8,2]],"virtual");
         addGroup([[6,1]],"virtual");
         addGroup([[9,2],[9,3]],"virtual");
         addGroup([[8,4],[9,4]],"virtual");
         addGroup([[3,4],[3,5]],"virtual");
         addGroup([[4,4]],"virtual");
         addGroup([[4,3]],"virtual");
         addGroup([[5,4]],"virtual",true,"hohohohoho");
         addGroup([[1,4]],"virtual");
         addGroup([[1,3]],"virtual");
         addGroup([[1,2],[2,1],[2,2]],"virtual");
         addGroup([[3,1],[4,1]],"virtual");
         addGroup([[5,1]],"virtual");
         addGroup(get2DArray([0,0],[10,0]),"virtual");
         addGroup(get2DArray([0,1],[0,10]),"virtual");
         addGroup(get2DArray([1,10],[10,10]),"virtual");
         addGroup(get2DArray([10,1],[10,9]),"virtual");
         addGroup([[4,5]],"book",false,2);
         addGroup([[2,7]],"book",false,4);
         addGroup([[5,6]],"book",false,5);
         addGroup([[8,3]],"book",false,8);
         addGroup([[1,1]],"book",false,11);
      }
      
      public function getMessage(param1:int) : String
      {
         return messages[param1 - 1][Language._languageNum];
      }
      
      private function setManPosition(param1:Array) : void
      {
         var _loc2_:int = 0;
         _loc2_ = 0;
         while(_loc2_ < param1.length)
         {
            cMan.push(param1[_loc2_]);
            _loc2_++;
         }
      }
      
      private function addEntrances() : void
      {
         addEntrance([0,5],["B"],-1);
         addEntrance([5,0],["R"],-4);
         addEntrance([10,5],["T"],-3);
         addEntrance([5,10],["L"],-2);
         addEntrance([5,5],["T"],1,0);
         addEntrance([4,6],["L"],2,0);
         addEntrance([4,7],["T"],2,1);
         addEntrance([3,7],["L"],3,0);
         addEntrance([3,7],["B"],3,1);
         addEntrance([2,5],["B"],4,0);
         addEntrance([2,6],["R"],4,1);
         addEntrance([3,6],["R"],4,2);
         addEntrance([1,8],["L"],5,0);
         addEntrance([2,8],["L"],5,1);
         addEntrance([2,9],["B"],5,2);
         addEntrance([1,6],["L"],6,0);
         addEntrance([1,7],["R"],6,1);
         addEntrance([3,9],["L"],7,0);
         addEntrance([3,9],["T"],7,1);
         addEntrance([4,8],["T"],8,0);
         addEntrance([4,8],["B"],8,1);
         addEntrance([5,7],["L"],9,0);
         addEntrance([6,7],["L"],9,1);
         addEntrance([5,8],["T"],9,2);
         addEntrance([6,6],["L"],10,0);
         addEntrance([6,6],["R"],10,1);
         addEntrance([6,6],["B"],10,2);
         addEntrance([7,6],["T"],11,0);
         addEntrance([8,6],["B"],11,1);
         addEntrance([8,6],["R"],11,2);
         addEntrance([8,7],["L"],12,0);
         addEntrance([8,7],["T"],12,1);
         addEntrance([7,8],["L"],13,0);
         addEntrance([6,9],["T"],13,1);
         addEntrance([7,9],["B"],13,2);
         addEntrance([9,6],["T"],14,0);
         addEntrance([9,6],["R"],14,1);
         addEntrance([9,8],["L"],15,0);
         addEntrance([8,9],["T"],15,1);
         addEntrance([7,4],["L"],16,0);
         addEntrance([6,5],["R"],16,1);
         addEntrance([7,3],["L"],17,0);
         addEntrance([7,3],["R"],17,1);
         addEntrance([7,1],["T"],18,0);
         addEntrance([7,2],["R"],18,1);
         addEntrance([8,1],["B"],18,2);
         addEntrance([6,1],["B"],19,0);
         addEntrance([9,2],["L"],20,0);
         addEntrance([9,3],["T"],20,1);
         addEntrance([9,3],["R"],20,2);
         addEntrance([9,4],["L"],21,0);
         addEntrance([9,4],["R"],21,1);
         addEntrance([3,4],["B"],22,0);
         addEntrance([3,5],["T"],22,1);
         addEntrance([4,4],["L"],23,0);
         addEntrance([4,4],["T"],23,1);
         addEntrance([4,4],["B"],23,2);
         addEntrance([4,3],["R"],24,0);
         addEntrance([5,4],["T"],25,0);
         addEntrance([1,4],["L"],26,0);
         addEntrance([1,4],["B"],26,1);
         addEntrance([1,3],["L"],27,0);
         addEntrance([1,3],["R"],27,1);
         addEntrance([1,2],["L"],28,0);
         addEntrance([1,2],["R"],28,1);
         addEntrance([2,1],["B"],28,2);
         addEntrance([3,1],["T"],29,0);
         addEntrance([4,1],["B"],29,1);
         addEntrance([5,1],["L"],30,0);
         addEntrance([5,1],["T"],30,1);
      }
      
      private function addGroup(param1:Array, param2:String = "wall", param3:Boolean = true, param4:* = null) : void
      {
         cRoom.push({
            "points":param1,
            "type":param2,
            "isStatic":param3,
            "extra":param4
         });
      }
      
      private function addEntrance(param1:Array, param2:Array, param3:int, param4:uint = 0) : void
      {
         var _loc5_:* = undefined;
         for each(_loc5_ in param2)
         {
            switch(_loc5_)
            {
               case "L":
                  mapEntrances.push({
                     "point":param1,
                     "x":param1[1] * 50 - 25,
                     "y":param1[0] * 50,
                     "id":param3,
                     "entranceId":param4,
                     "dir":"L"
                  });
                  break;
               case "R":
                  mapEntrances.push({
                     "point":param1,
                     "x":param1[1] * 50 + 25,
                     "y":param1[0] * 50,
                     "id":param3,
                     "entranceId":param4,
                     "dir":"R"
                  });
                  break;
               case "T":
                  mapEntrances.push({
                     "point":param1,
                     "x":param1[1] * 50,
                     "y":param1[0] * 50 - 25,
                     "id":param3,
                     "entranceId":param4,
                     "dir":"T"
                  });
                  break;
               case "B":
                  mapEntrances.push({
                     "point":param1,
                     "x":param1[1] * 50,
                     "y":param1[0] * 50 + 25,
                     "id":param3,
                     "entranceId":param4,
                     "dir":"B"
                  });
                  break;
            }
         }
      }
   }
}
