package game
{
   import flash.display.MovieClip;
   import flash.display.StageQuality;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.net.URLRequest;
   import flash.net.navigateToURL;
   import flash.text.TextField;
   import flash.utils.getTimer;
   
   [Embed(source="/_assets/assets.swf", symbol="game.SettingField")]
   public class SettingField extends MovieClip
   {
       
      
      private var TotalTime:Number;
      
      private var onTxt:Array;
      
      private var alertMc:MovieClip;
      
      public var quaBtn:btnquality;
      
      private var timeTxt:TextField;
      
      private var btn_qua:MovieClip;
      
      private var btn_quit:MovieClip;
      
      private var cookie:Cookie;
      
      public var txt:TextField;
      
      private var highTxt:Array;
      
      private var b_logo:MovieClip;
      
      private var startTime:Number;
      
      public var _b_logo:MovieClip;
      
      public var s_alert:MovieClip;
      
      private var btn_more:MovieClip;
      
      private var soundMgr:SoundManager;
      
      private var offTxt:Array;
      
      private var btn_on:MovieClip;
      
      public var quitBtn:btnquit;
      
      private var _btn_quit:MovieClip;
      
      private var mediumTxt:Array;
      
      public var moreBtn:btnmoreGame;
      
      public var gameTime:Number;
      
      private var btn_back:MovieClip;
      
      public var onBtn:btn_sound;
      
      public function SettingField()
      {
         super();
         onTxt = ["ON","开","AAN","ACTIVÉ","AN","WŁĄCZ","PÅ","ON","SÍ","LIGADO","HIDUPKAN","ВКЛЮЧИТЬ","ON","ON","AÇIK","HIDUPKAN","LIGADO"];
         offTxt = ["OFF","关","UIT","DÉSACTIVÉ","AUS","WYŁĄCZ","AV","OFF","NO","DESLIGADO","MATIKAN","ВЫКЛЮЧИТЬ","OFF","OFF","KAPALI","MATIKAN","DESLIGADO"];
         highTxt = ["HIGH","高","HIGH","HAUTE","HOCH","WYSOKA","HÖG","ALTA","ALTA","ALTA","TINGGI","ВЫСОКОЕ","HIGH","HIGH","YÜKSEK","TINGGI","ÓPTIMA"];
         mediumTxt = ["NORMAL","普通","NORMAL","NORMALE","NORMAL","ŚREDNIA","NORMAL","NORMALE","NORMAL","NORMAL","NORMAL","СРЕДНЕЕ","NORMAL","NORMAL","NORMAL","MEDIUM","NORMAL"];
         cookie = Cookie.getInstance();
         soundMgr = SoundManager.getInstance();
         TotalTime = cookie.getValue("time") == null ? 0 : cookie.getValue("time");
         startTime = getTimer();
         alertMc = getChildByName("s_alert") as MovieClip;
         alertMc.visible = false;
         this.addEventListener(Event.ADDED_TO_STAGE,init,false,0,true);
      }
      
      private function init(param1:Event) : void
      {
         this.removeEventListener(Event.ADDED_TO_STAGE,init);
         btn_back = alertMc.getChildByName("backBtn") as MovieClip;
         _btn_quit = alertMc.getChildByName("quitBtn") as MovieClip;
         btn_on = getChildByName("onBtn") as MovieClip;
         btn_qua = getChildByName("quaBtn") as MovieClip;
         btn_quit = getChildByName("quitBtn") as MovieClip;
         btn_more = getChildByName("moreBtn") as MovieClip;
         timeTxt = getChildByName("txt") as TextField;
         btn_back.addEventListener(MouseEvent.CLICK,removeAlert,false,0,true);
         _btn_quit.addEventListener(MouseEvent.CLICK,quitGame,false,0,true);
         btn_qua.addEventListener(MouseEvent.CLICK,turnQuality,false,0,true);
         btn_on.addEventListener(MouseEvent.CLICK,turnSound,false,0,true);
         btn_quit.addEventListener(MouseEvent.CLICK,showAlert,false,0,true);
         btn_more.addEventListener(MouseEvent.CLICK,jumpURL,false,0,true);
         b_logo = getChildByName("_b_logo") as MovieClip;
         b_logo.buttonMode = true;
         b_logo.addEventListener(MouseEvent.CLICK,jumpURL,false,0,true);
         if(cookie.getValue("soundOn") == false)
         {
            SoundManager.getInstance().turnSound(false);
            btn_on.txt.text = offTxt[Language._languageNum];
         }
         else
         {
            SoundManager.getInstance().turnSound(true);
            btn_on.txt.text = onTxt[Language._languageNum];
         }
         setQuality(cookie.getValue("quality") == null ? 2 : cookie.getValue("quality"));
      }
      
      private function setQuality(param1:uint) : void
      {
         cookie.saveValue(param1,"quality");
         switch(param1)
         {
            case 0:
               stage.quality = StageQuality.MEDIUM;
               btn_qua.txt.text = mediumTxt[Language._languageNum];
               break;
            case 1:
               stage.quality = StageQuality.HIGH;
               btn_qua.txt.text = highTxt[Language._languageNum];
               break;
            case 2:
               stage.quality = StageQuality.MEDIUM;
               btn_qua.txt.text = mediumTxt[Language._languageNum];
               break;
            case 3:
               stage.quality = StageQuality.HIGH;
               btn_qua.txt.text = highTxt[Language._languageNum];
         }
      }
      
      private function removeAlert(param1:MouseEvent) : void
      {
         Model.getInstance().currentRoom.visible = true;
         alertMc.visible = false;
         Model.disableKeyBoard = false;
      }
      
      private function showAlert(param1:MouseEvent) : void
      {
         if(!Model.disableKeyBoard && !Model.isGameOver && Model.getInstance().currentRoom != null)
         {
            Model.getInstance().currentRoom.visible = false;
            alertMc.visible = true;
            Model.disableKeyBoard = true;
         }
      }
      
      private function jumpURL(param1:MouseEvent) : void
      {
         navigateToURL(new URLRequest(Language.url1),"_blank");
      }
      
      private function turnSound(param1:MouseEvent = null) : void
      {
         if(soundMgr.soundOn == true)
         {
            soundMgr.turnSound(false);
            btn_on.txt.text = offTxt[Language._languageNum];
         }
         else
         {
            soundMgr.turnSound(true);
            btn_on.txt.text = onTxt[Language._languageNum];
         }
      }
      
      public function update() : void
      {
         var _loc1_:Number = NaN;
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         gameTime = getTimer() - startTime + TotalTime;
         _loc1_ = Math.floor(gameTime / 3600000);
         _loc2_ = Math.floor(gameTime / 60000) % 60;
         _loc3_ = Math.floor(gameTime / 1000) % 60;
         timeTxt.text = (_loc1_ > 9 ? _loc1_ : 0 + String(_loc1_)) + " :" + (_loc2_ > 9 ? _loc2_ : 0 + String(_loc2_)) + " :" + (_loc3_ > 9 ? _loc3_ : 0 + String(_loc3_));
      }
      
      private function turnQuality(param1:MouseEvent) : void
      {
         setQuality((cookie.getValue("quality") + 1) % 4);
      }
      
      private function quitGame(param1:MouseEvent) : void
      {
         Model.disableKeyBoard = false;
         BroadCaster.getInstance().run("onQuitGame","");
      }
      
      public function saveTime() : void
      {
         Model.getInstance().currentData.time = gameTime;
      }
   }
}
